/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : SCI1.C
**     Project   : _8037_exp
**     Processor : 56F8037
**     Component : Init_SCI
**     Version   : Component 01.083, Driver 01.19, CPU db: 2.87.263
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 2010-09-18,  12:16
**     Abstract  :
**         This "Init_SCI" Peripheral Inspector implements the
**         Serial Communications Interface module (SCI), basic
**         initialization and settings.
**     Settings  :
**         Serial channel              : QSCI1
**
**         Communication setting
**             Divisor value           : 52
**             Init baud rate          : 38461.538462 Bd
**             Data format             : 8 bits
**             Wakeup                  : by idle line
**             Polarity                : normal
**             Parity                  : none
**             SCI run in Wait mode    : Disabled
**
**         Interrupts
**           Receiver Full             : Enabled
**             ISR name                : isr_rx_full
**             Interrupt name          : INT_QSCI1_RxFull
**             Priority                : 1
**
**           Receiver Error            : Disabled
**
**           Transmitter Complete      : Disabled
**
**           Transmitter Ready         : Enabled
**             ISR name                : isr_tx_empty
**             Interrupt name          : INT_QSCI1_TxEmpty
**             Priority                : 1
**
**     Contents  :
**         Init - void SCI1_Init(void);
**
**     Copyright : 1997 - 2009 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE SCI1. */

#include "SCI1.h"

/*
** ###################################################################
**
**  The following method(s) must be implemented by the user in one
**  of the following modules:
**
**    #if defined(isr_rx_full_FAST_INT)
**    #pragma interrupt fast
**    #elif defined(isr_rx_full_VECT_TABLE_ISR_FAST_INT)
**    #pragma define_section interrupt_fast "interrupt_fast.text"  RX
**    #pragma section interrupt_fast begin
**    #pragma interrupt fast
**    #else
**    #pragma interrupt
**    #endif
**    void isr_rx_full(void)
**    {
**      // Your interrupt code
**    }
**    #if defined(isr_rx_full_VECT_TABLE_ISR_FAST_INT)
**    #pragma section interrupt_fast end
**    #endif
**
**    #if defined(isr_tx_empty_FAST_INT)
**    #pragma interrupt fast
**    #elif defined(isr_tx_empty_VECT_TABLE_ISR_FAST_INT)
**    #pragma define_section interrupt_fast "interrupt_fast.text"  RX
**    #pragma section interrupt_fast begin
**    #pragma interrupt fast
**    #else
**    #pragma interrupt
**    #endif
**    void isr_tx_empty(void)
**    {
**      // Your interrupt code
**    }
**    #if defined(isr_tx_empty_VECT_TABLE_ISR_FAST_INT)
**    #pragma section interrupt_fast end
**    #endif
**
**  Modules:
**       _8037_exp
**       Events
**
** ###################################################################
*/

/*
** ===================================================================
**     Method      :  SCI1_Init (component Init_SCI)
**
**     Description :
**         This method initializes registers of the SCI module
**         according to this Peripheral Initialization Bean settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see "Call Init method" property of the
**         bean for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void SCI1_Init(void)
{
  getReg(QSCI1_STAT);                  /* Clear interrupt request flags */
  /* QSCI1_RATE: SBR=0x34,FRAC_SBR=0 */
  setReg16(QSCI1_RATE, 0x01A0U);       /* Set prescaler bits */ 
  /* QSCI1_CTRL1: LOOP=0,SWAI=1,RSRC=0,M=0,WAKE=0,POL=0,PE=0,PT=0,TEIE=1,TIIE=0,RFIE=1,REIE=0,TE=1,RE=1,RWU=0,SBK=0 */
  setReg16(QSCI1_CTRL1, 0x40ACU);      /* Set the SCI control register */ 
  /* QSCI1_CTRL2: TFCNT=0,TFWM=0,RFCNT=0,RFWM=0,FIFO_EN=0,??=0,LIN_MODE=0,??=0,??=0,??=0 */
  setReg16(QSCI1_CTRL2, 0x00U);        /* Set the SCI control register */ 
}

/* END SCI1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 3.00 [04.35]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
