// EOnCE Memory Map 

#define OTx1_ORx1	0xFFFFFF
#define OTx_ORx		0xFFFFFE
#define OTxRxSR		0xFFFFFD
#define OCLSR		0xFFFFFC
#define OCR			0xFFFFA0
#define OSCNTR		0xFFFF9E
#define OSR			0xFFFF9D
#define OBASE		0xFFFF9C
#define OTBCR		0xFFFF9B
#define OTBPR		0xFFFF9A
#define OTB			0xFFFF98
#define OBCR		0xFFFF96
#define OBAR1		0xFFFF94
#define OBAR2		0xFFFF92
#define OBMSK		0xFFFF90
#define OBCNTR		0xFFFF8E
#define OESCR		0xFFFF8A

// High-level peripheral map 

#define TMRA_BASE   0x00F000
#define TMRB_BASE   0x00F040
#define ADC_BASE    0x00F080
#define PWM_BASE    0x00F0C0
#define ITCN_BASE 	0x00F0E0
#define SIM_BASE    0x00F100
#define COP_BASE    0x00F120
#define OCCS_BASE   0x00F130
#define PS_BASE     0x00f140
#define GPIOA_BASE  0x00F150
#define GPIOB_BASE  0x00F160
#define GPIOC_BASE  0x00F170
#define GPIOD_BASE  0x00F180
#define PIT0_BASE   0x00F190
#define PIT1_BASE   0x00F1A0
#define PIT2_BASE   0x00F1B0
#define DAC0_BASE   0x00F1C0
#define DAC1_BASE   0x00F1D0
#define CMPA_BASE   0x00F1E0
#define CMPB_BASE   0x00F1F0
#define SCI0_BASE   0x00F200
#define SCI1_BASE   0x00F210
#define SPI0_BASE  	0x00F220
#define SPI1_BASE  	0x00F230
#define I2C_BASE  	0x00F280
#define FM_BASE     0x00f400
#define MSCAN_BASE  0x00f800
#define QSCIO0_BASE 0x00F200
#define QSCIO1_BASE 0x00F210

// Lower level register map in same order above:
#define TMRA0_COMP1   (TMRA_BASE   + 0x0 ) //Compare Register 1
#define TMRA0_COMP2   (TMRA_BASE   + 0x1 ) //Compare Register 2
#define TMRA0_CAPT    (TMRA_BASE   + 0x2 ) //Capture Register
#define TMRA0_LOAD    (TMRA_BASE   + 0x3 ) //Load Register
#define TMRA0_HOLD    (TMRA_BASE   + 0x4 ) //Hold Register
#define TMRA0_CNTR    (TMRA_BASE   + 0x5 ) //Counter Register
#define TMRA0_CTRL    (TMRA_BASE   + 0x6 ) //Control Register
#define TMRA0_SCTRL   (TMRA_BASE   + 0x7 ) //Status and Control Register
#define TMRA0_CMPLD1  (TMRA_BASE   + 0x8 ) //Comparator Load Register 1
#define TMRA0_CMPLD2  (TMRA_BASE   + 0x9 ) //Comparator Load Register 2
#define TMRA0_CSCTRL  (TMRA_BASE   + 0xA ) //Comparator Status and Control Register
#define TMRA0_FILT    (TMRA_BASE   + 0xB ) //Input Filter Register
#define TMRA0_ENBL    (TMRA_BASE   + 0xF ) //Timer Channel Enable Register
#define TMRA1_COMP1   (TMRA_BASE   + 0x10) //Compare Register 1
#define TMRA1_COMP2   (TMRA_BASE   + 0x11) //Compare Register 2
#define TMRA1_CAPT    (TMRA_BASE   + 0x12) //Capture Register
#define TMRA1_LOAD    (TMRA_BASE   + 0x13) //Load Register
#define TMRA1_HOLD    (TMRA_BASE   + 0x14) //Hold Register
#define TMRA1_CNTR    (TMRA_BASE   + 0x15) //Counter Register
#define TMRA1_CTRL    (TMRA_BASE   + 0x16) //Control Register
#define TMRA1_SCTRL   (TMRA_BASE   + 0x17) //Status and Control Register
#define TMRA1_CMPLD1  (TMRA_BASE   + 0x18) //Comparator Load Register 1
#define TMRA1_CMPLD2  (TMRA_BASE   + 0x19) //Comparator Load Register 2
#define TMRA1_CSCTRL  (TMRA_BASE   + 0x1A) //Comparator Status and Control Register
#define TMRA1_FILT    (TMRA_BASE   + 0x1B) //Input Filter Register
#define TMRA2_COMP1   (TMRA_BASE   + 0x20) //Compare Register 1
#define TMRA2_COMP2   (TMRA_BASE   + 0x21) //Compare Register 2
#define TMRA2_CAPT    (TMRA_BASE   + 0x22) //Capture Register
#define TMRA2_LOAD    (TMRA_BASE   + 0x23) //Load Register
#define TMRA2_HOLD    (TMRA_BASE   + 0x24) //Hold Register
#define TMRA2_CNTR    (TMRA_BASE   + 0x25) //Counter Register
#define TMRA2_CTRL    (TMRA_BASE   + 0x26) //Control Register
#define TMRA2_SCTRL   (TMRA_BASE   + 0x27) //Status and Control Register
#define TMRA2_CMPLD1  (TMRA_BASE   + 0x28) //Comparator Load Register 1
#define TMRA2_CMPLD2  (TMRA_BASE   + 0x29) //Comparator Load Register 2
#define TMRA2_CSCTRL  (TMRA_BASE   + 0x2A) //Comparator Status and Control Register
#define TMRA2_FILT    (TMRA_BASE   + 0x2B) //Input Filter Register
#define TMRA3_COMP1   (TMRA_BASE   + 0x30) //Compare Register 1
#define TMRA3_COMP2   (TMRA_BASE   + 0x31) //Compare Register 2
#define TMRA3_CAPT    (TMRA_BASE   + 0x32) //Capture Register
#define TMRA3_LOAD    (TMRA_BASE   + 0x33) //Load Register
#define TMRA3_HOLD    (TMRA_BASE   + 0x34) //Hold Register
#define TMRA3_CNTR    (TMRA_BASE   + 0x35) //Counter Register
#define TMRA3_CTRL    (TMRA_BASE   + 0x36) //Control Register
#define TMRA3_SCTRL   (TMRA_BASE   + 0x37) //Status and Control Register
#define TMRA3_CMPLD1  (TMRA_BASE   + 0x38) //Comparator Load Register 1
#define TMRA3_CMPLD2  (TMRA_BASE   + 0x39) //Comparator Load Register 2
#define TMRA3_CSCTRL  (TMRA_BASE   + 0x3A) //Comparator Status and Control Register
#define TMRA3_FILT    (TMRA_BASE   + 0x3B) //Input Filter Register
#define TMRB0_COMP1   (TMRB_BASE   + 0x0 ) //Compare Register 1
#define TMRB0_COMP2   (TMRB_BASE   + 0x1 ) //Compare Register 2
#define TMRB0_CAPT    (TMRB_BASE   + 0x2 ) //Capture Register
#define TMRB0_LOAD    (TMRB_BASE   + 0x3 ) //Load Register
#define TMRB0_HOLD    (TMRB_BASE   + 0x4 ) //Hold Register
#define TMRB0_CNTR    (TMRB_BASE   + 0x5 ) //Counter Register
#define TMRB0_CTRL    (TMRB_BASE   + 0x6 ) //Control Register
#define TMRB0_SCTRL   (TMRB_BASE   + 0x7 ) //Status and Control Register
#define TMRB0_CMPLD1  (TMRB_BASE   + 0x8 ) //Comparator Load Register 1
#define TMRB0_CMPLD2  (TMRB_BASE   + 0x9 ) //Comparator Load Register 2
#define TMRB0_CSCTRL  (TMRB_BASE   + 0xA ) //Comparator Status and Control Register
#define TMRB0_FILT    (TMRB_BASE   + 0xB ) //Input Filter Register
#define TMRB0_ENBL    (TMRB_BASE   + 0xF ) //Timer Channel Enable Register
#define TMRB1_COMP1   (TMRB_BASE   + 0x10) //Compare Register 1
#define TMRB1_COMP2   (TMRB_BASE   + 0x11) //Compare Register 2
#define TMRB1_CAPT    (TMRB_BASE   + 0x12) //Capture Register
#define TMRB1_LOAD    (TMRB_BASE   + 0x13) //Load Register
#define TMRB1_HOLD    (TMRB_BASE   + 0x14) //Hold Register
#define TMRB1_CNTR    (TMRB_BASE   + 0x15) //Counter Register
#define TMRB1_CTRL    (TMRB_BASE   + 0x16) //Control Register
#define TMRB1_SCTRL   (TMRB_BASE   + 0x17) //Status and Control Register
#define TMRB1_CMPLD1  (TMRB_BASE   + 0x18) //Comparator Load Register 1
#define TMRB1_CMPLD2  (TMRB_BASE   + 0x19) //Comparator Load Register 2
#define TMRB1_CSCTRL  (TMRB_BASE   + 0x1A) //Comparator Status and Control Register
#define TMRB1_FILT    (TMRB_BASE   + 0x1B) //Input Filter Register
#define TMRB2_COMP1   (TMRB_BASE   + 0x20) //Compare Register 1
#define TMRB2_COMP2   (TMRB_BASE   + 0x21) //Compare Register 2
#define TMRB2_CAPT    (TMRB_BASE   + 0x22) //Capture Register
#define TMRB2_LOAD    (TMRB_BASE   + 0x23) //Load Register
#define TMRB2_HOLD    (TMRB_BASE   + 0x24) //Hold Register
#define TMRB2_CNTR    (TMRB_BASE   + 0x25) //Counter Register
#define TMRB2_CTRL    (TMRB_BASE   + 0x26) //Control Register
#define TMRB2_SCTRL   (TMRB_BASE   + 0x27) //Status and Control Register
#define TMRB2_CMPLD1  (TMRB_BASE   + 0x28) //Comparator Load Register 1
#define TMRB2_CMPLD2  (TMRB_BASE   + 0x29) //Comparator Load Register 2
#define TMRB2_CSCTRL  (TMRB_BASE   + 0x2A) //Comparator Status and Control Register
#define TMRB2_FILT    (TMRB_BASE   + 0x2B) //Input Filter Register
#define TMRB3_COMP1   (TMRB_BASE   + 0x30) //Compare Register 1
#define TMRB3_COMP2   (TMRB_BASE   + 0x31) //Compare Register 2
#define TMRB3_CAPT    (TMRB_BASE   + 0x32) //Capture Register
#define TMRB3_LOAD    (TMRB_BASE   + 0x33) //Load Register
#define TMRB3_HOLD    (TMRB_BASE   + 0x34) //Hold Register
#define TMRB3_CNTR    (TMRB_BASE   + 0x35) //Counter Register
#define TMRB3_CTRL    (TMRB_BASE   + 0x36) //Control Register
#define TMRB3_SCTRL   (TMRB_BASE   + 0x37) //Status and Control Register
#define TMRB3_CMPLD1  (TMRB_BASE   + 0x38) //Comparator Load Register 1
#define TMRB3_CMPLD2  (TMRB_BASE   + 0x39) //Comparator Load Register 2
#define TMRB3_CSCTRL  (TMRB_BASE   + 0x3A) //Comparator Status and Control Register
#define TMRB3_FILT    (TMRB_BASE   + 0x3B) //Input Filter Register
#define ADC_CTRL1     (ADC_BASE    + 0x0 ) //Control Register 1
#define ADC_CTRL2     (ADC_BASE    + 0x1 ) //Control Register 2
#define ADC_ZXCTRL    (ADC_BASE    + 0x2 ) //Zero Crossing Control Register
#define ADC_CLIST1    (ADC_BASE    + 0x3 ) // Channel List Register 1
#define ADC_CLIST2    (ADC_BASE    + 0x4 ) // Channel List Register 2
#define ADC_CLIST3    (ADC_BASE    + 0x5 ) // Channel List Register 3
#define ADC_CLIST4    (ADC_BASE    + 0x6 ) // Channel List Register 4
#define ADC_SDIS      (ADC_BASE    + 0x7 ) //Sample Disable Register
#define ADC_STAT      (ADC_BASE    + 0x8 ) //Status Register
#define ADC_RDY       (ADC_BASE    + 0x9 ) //Conversion Ready Register
#define ADC_LIMSTAT   (ADC_BASE    + 0xA ) //Limit Status Register
#define ADC_ZXSTAT    (ADC_BASE    + 0xB ) //Zero Crossing Status Register
#define ADC_RSLT0     (ADC_BASE    + 0xC ) //Result Register 0
#define ADC_RSLT1     (ADC_BASE    + 0xD ) //Result Register 1
#define ADC_RSLT2     (ADC_BASE    + 0xE ) //Result Register 2
#define ADC_RSLT3     (ADC_BASE    + 0xF ) //Result Register 3
#define ADC_RSLT4     (ADC_BASE    + 0x10) //Result Register 4
#define ADC_RSLT5     (ADC_BASE    + 0x11) //Result Register 5
#define ADC_RSLT6     (ADC_BASE    + 0x12) //Result Register 6
#define ADC_RSLT7     (ADC_BASE    + 0x13) //Result Register 7
#define ADC_RSLT8     (ADC_BASE    + 0x14) //Result Register 8
#define ADC_RSLT9     (ADC_BASE    + 0x15) //Result Register 9
#define ADC_RSLT10    (ADC_BASE    + 0x16) //Result Register 10
#define ADC_RSLT11    (ADC_BASE    + 0x17) //Result Register 11
#define ADC_RSLT12    (ADC_BASE    + 0x18) //Result Register 12
#define ADC_RSLT13    (ADC_BASE    + 0x19) //Result Register 13
#define ADC_RSLT14    (ADC_BASE    + 0x1A) //Result Register 14
#define ADC_RSLT15    (ADC_BASE    + 0x1B) //Result Register 15
#define ADC_LOLIM0    (ADC_BASE    + 0x1C) //Low Limit Register 0
#define ADC_LOLIM1    (ADC_BASE    + 0x1D) //Low Limit Register 1
#define ADC_LOLIM2    (ADC_BASE    + 0x1E) //Low Limit Register 2
#define ADC_LOLIM3    (ADC_BASE    + 0x1F) //Low Limit Register 3
#define ADC_LOLIM4    (ADC_BASE    + 0x20) //Low Limit Register 4
#define ADC_LOLIM5    (ADC_BASE    + 0x21) //Low Limit Register 5
#define ADC_LOLIM6    (ADC_BASE    + 0x22) //Low Limit Register 6
#define ADC_LOLIM7    (ADC_BASE    + 0x23) //Low Limit Register 7
#define ADC_HILIM0    (ADC_BASE    + 0x24) //High Limit Register 0
#define ADC_HILIM1    (ADC_BASE    + 0x25) //High Limit Register 1
#define ADC_HILIM2    (ADC_BASE    + 0x26) //High Limit Register 2
#define ADC_HILIM3    (ADC_BASE    + 0x27) //High Limit Register 3
#define ADC_HILIM4    (ADC_BASE    + 0x28) //High Limit Register 4
#define ADC_HILIM5    (ADC_BASE    + 0x29) //High Limit Register 5
#define ADC_HILIM6    (ADC_BASE    + 0x2A) //High Limit Register 6
#define ADC_HILIM7    (ADC_BASE    + 0x2B) //High Limit Register 7
#define ADC_OFFST0    (ADC_BASE    + 0x2C) //Offset Register 0
#define ADC_OFFST1    (ADC_BASE    + 0x2D) //Offset Register 1
#define ADC_OFFST2    (ADC_BASE    + 0x2E) //Offset Register 2
#define ADC_OFFST3    (ADC_BASE    + 0x2F) //Offset Register 3
#define ADC_OFFST4    (ADC_BASE    + 0x30) //Offset Register 4
#define ADC_OFFST5    (ADC_BASE    + 0x31) //Offset Register 5
#define ADC_OFFST6    (ADC_BASE    + 0x32) //Offset Register 6
#define ADC_OFFST7    (ADC_BASE    + 0x33) //Offset Register 7
#define ADC_PWR       (ADC_BASE    + 0x34) //Power Control Register
#define ADC_CAL       (ADC_BASE    + 0x35) //Calibration Register
#define PWM_CTRL      (PWM_BASE    + 0x0 ) //Control Register
#define PWM_FCTRL     (PWM_BASE    + 0x1 ) //Fault Control Register
#define PWM_FLTACK    (PWM_BASE    + 0x2 ) //Fault Status Acknowledge Register
#define PWM_OUT       (PWM_BASE    + 0x3 ) //Output Control Register
#define PWM_CNTR      (PWM_BASE    + 0x4 ) //Counter Register
#define PWM_CMOD      (PWM_BASE    + 0x5 ) //Counter Modulo Register
#define PWM_VAL0      (PWM_BASE    + 0x6 ) //Value Register 0
#define PWM_VAL1      (PWM_BASE    + 0x7 ) //Value Register 1
#define PWM_VAL2      (PWM_BASE    + 0x8 ) //Value Register 2
#define PWM_VAL3      (PWM_BASE    + 0x9 ) //Value Register 3
#define PWM_VAL4      (PWM_BASE    + 0xA ) //Value Register 4
#define PWM_VAL5      (PWM_BASE    + 0xB ) //Value Register 5
#define PWM_DTIM0     (PWM_BASE    + 0xC ) //Dead Time Register 0
#define PWM_DTIM1     (PWM_BASE    + 0xD ) //Dead Time Register 1
#define PWM_DMAP1     (PWM_BASE    + 0xE ) //Disable Mapping Register 1
#define PWM_DMAP2     (PWM_BASE    + 0xF ) //Disable Mapping Register 2
#define PWM_CNFG      (PWM_BASE    + 0x10) //Configure Register
#define PWM_CCTRL     (PWM_BASE    + 0x11) //Channel Control Register
#define PWM_PORT      (PWM_BASE    + 0x12) //Port Register
#define PWM_ICCTRL    (PWM_BASE    + 0x13) //Internal Correction Control Register
#define PWM_SCTRL     (PWM_BASE    + 0x14) //Source Control Register
#define PWM_SYNC      (PWM_BASE    + 0x15) //Synchronization Window Register
#define PWM_FFILT0    (PWM_BASE    + 0x16) //Fault0 Filter Register
#define PWM_FFILT1    (PWM_BASE    + 0x17) //Fault1 Filter Register
#define PWM_FFILT2    (PWM_BASE    + 0x18) //Fault2 Filter Register
#define PWM_FFILT3    (PWM_BASE    + 0x19) //Fault3 Filter Register
#define ITCN_IPR0     (ITCN_BASE   + 0x0 ) //Interrupt Priority Register 0
#define ITCN_IPR1     (ITCN_BASE   + 0x1 ) //Interrupt Priority Register 1
#define ITCN_IPR2     (ITCN_BASE   + 0x2 ) //Interrupt Priority Register 2
#define ITCN_IPR3     (ITCN_BASE   + 0x3 ) //Interrupt Priority Register 3
#define ITCN_IPR4     (ITCN_BASE   + 0x4 ) //Interrupt Priority Register 4
#define ITCN_IPR5     (ITCN_BASE   + 0x5 ) //Interrupt Priority Register 5
#define ITCN_IPR6     (ITCN_BASE   + 0x6 ) //Interrupt Priority Register 6
#define ITCN_VBA      (ITCN_BASE   + 0x7 ) //Vector Base Address Register
#define ITCN_FIM0     (ITCN_BASE   + 0x8 ) //Fast Interrupt Match 0 Register
#define ITCN_FIVAL0   (ITCN_BASE   + 0x9 ) //Fast Interrupt Vector Address Low 0 Register
#define ITCN_FIVAH0   (ITCN_BASE   + 0xA ) //Fast Interrupt Vector Address High 0 Register
#define ITCN_FIM1     (ITCN_BASE   + 0xB ) //Fast Interrupt Match 1 Register
#define ITCN_FIVAL1   (ITCN_BASE   + 0xC ) //Fast Interrupt Vector Address Low 1 Register
#define ITCN_FIVAH1   (ITCN_BASE   + 0xD ) //Fast Interrupt Vector Address High 1 Register
#define ITCN_IRQP0    (ITCN_BASE   + 0xE ) //IRQ Pending Register 0
#define ITCN_IRQP1    (ITCN_BASE   + 0xF ) //IRQ Pending Register 1
#define ITCN_IRQP2    (ITCN_BASE   + 0x10) //IRQ Pending Register 2
#define ITCN_IRQP3    (ITCN_BASE   + 0x11) //IRQ Pending Register 3
#define ITCN_ICTRL    (ITCN_BASE   + 0x16) //Interrupt Control Register
#define SIM_CTRL      (SIM_BASE    + 0x0 ) //Control Register
#define SIM_RSTAT     (SIM_BASE    + 0x1 ) //Reset Status Register
#define SIM_SWC0      (SIM_BASE    + 0x2 ) //Software Control Register 0
#define SIM_SWC1      (SIM_BASE    + 0x3 ) //Software Control Register 1
#define SIM_SWC2      (SIM_BASE    + 0x4 ) //Software Control Register 2
#define SIM_SWC3      (SIM_BASE    + 0x5 ) //Software Control Register 3
#define SIM_MSHID     (SIM_BASE    + 0x6 ) //Most Significant Half JTAG ID
#define SIM_LSHID     (SIM_BASE    + 0x7 ) //Least Significant Half JTAG ID
#define SIM_PWR       (SIM_BASE    + 0x8 ) //Power Control Register
#define SIM_CLKOUT    (SIM_BASE    + 0xA ) //Clock Out Select Register
#define SIM_PCR       (SIM_BASE    + 0xB ) //Peripheral Clock Rate Register
#define SIM_PCE0      (SIM_BASE    + 0xC ) //Peripheral Clock Enable Register 0
#define SIM_PCE1      (SIM_BASE    + 0xD ) //Peripheral Clock Enable Register 1
#define SIM_SD0       (SIM_BASE    + 0xE ) //Peripheral STOP Disable Register 0
#define SIM_SD1       (SIM_BASE    + 0xF ) //Peripheral STOP Disable Register 1
#define SIM_IOSAHI    (SIM_BASE    + 0x10) //I/O Short Address Location High Register
#define SIM_IOSALO    (SIM_BASE    + 0x11) //I/O Short Address Location Low Register
#define SIM_PROT      (SIM_BASE    + 0x12) //Protection Register
#define SIM_GPSA0     (SIM_BASE    + 0x13) //GPIO Peripheral Select Register 0 for GPIOA
#define SIM_GPSA1     (SIM_BASE    + 0x14) //GPIO Peripheral Select Register 1 for GPIOA
#define SIM_GPSB0     (SIM_BASE    + 0x15) //GPIO Peripheral Select Register 0 for GPIOB
#define SIM_GPSB1     (SIM_BASE    + 0x16) //GPIO Peripheral Select Register 1 for GPIOB
#define SIM_GPSCD     (SIM_BASE    + 0x17) //GPIO Peripheral Select Register for GPIOC and GPIOD
#define SIM_IPS0      (SIM_BASE    + 0x18) //Internal Peripheral Source Select Register 0 for PWM
#define SIM_IPS1      (SIM_BASE    + 0x19) //Internal Peripheral Source Select Register 1 for DACs
#define SIM_IPS2      (SIM_BASE    + 0x1A) //Internal Peripheral Source Select Register 2 for TMRA
#define COP_CTRL      (COP_BASE    + 0x0 ) //Control Register
#define COP_TOUT      (COP_BASE    + 0x1 ) //Time-Out Register
#define COP_CNTR      (COP_BASE    + 0x2 ) //Counter Register
#define OCCS_CTRL     (OCCS_BASE   + 0x0 ) //Control Register
#define OCCS_DIVBY    (OCCS_BASE   + 0x1 ) //Divide-By Register
#define OCCS_STAT     (OCCS_BASE   + 0x2 ) //Status Register
#define OCCS_OCTRL    (OCCS_BASE   + 0x5 ) //Oscillator Control Register
#define OCCS_CLKCHK   (OCCS_BASE   + 0x6 ) //Clock Check Register
#define OCCS_PROT     (OCCS_BASE   + 0x7 ) //Protection Register
#define PS_CTRL       (PS_BASE     + 0x0 ) //Control Register
#define PS_STAT       (PS_BASE     + 0x1 ) //Status Register
#define GPIOA_PUPEN   (GPIOA_BASE  + 0x0 ) //Pull-up Enable Register
#define GPIOA_DATA    (GPIOA_BASE  + 0x1 ) //Data Register
#define GPIOA_DDIR    (GPIOA_BASE  + 0x2 ) //Data Direction Register
#define GPIOA_PEREN   (GPIOA_BASE  + 0x3 ) //Peripheral Enable Register
#define GPIOA_IASSRT  (GPIOA_BASE  + 0x4 ) //Interrupt Assert Register
#define GPIOA_IEN     (GPIOA_BASE  + 0x5 ) //Interrupt Enable Register
#define GPIOA_IPOL    (GPIOA_BASE  + 0x6 ) //Interrupt Polarity Register
#define GPIOA_IPEND   (GPIOA_BASE  + 0x7 ) //Interrupt Pending Register
#define GPIOA_IEDGE   (GPIOA_BASE  + 0x8 ) //Interrupt Edge-Sensitive Register
#define GPIOA_PPOUTM  (GPIOA_BASE  + 0x9 ) //Push-Pull Output Mode Control Register
#define GPIOA_RDATA   (GPIOA_BASE  + 0xA ) //Raw Data Input Register
#define GPIOA_DRIVE   (GPIOA_BASE  + 0xB ) //Output Drive Strength Control Register
#define GPIOB_PUPEN   (GPIOB_BASE  + 0x0 ) //Pull-up Enable Register
#define GPIOB_DATA    (GPIOB_BASE  + 0x1 ) //Data Register
#define GPIOB_DDIR    (GPIOB_BASE  + 0x2 ) //Data Direction Register
#define GPIOB_PEREN   (GPIOB_BASE  + 0x3 ) //Peripheral Enable Register
#define GPIOB_IASSRT  (GPIOB_BASE  + 0x4 ) //Interrupt Assert Register
#define GPIOB_IEN     (GPIOB_BASE  + 0x5 ) //Interrupt Enable Register
#define GPIOB_IPOL    (GPIOB_BASE  + 0x6 ) //Interrupt Polarity Register
#define GPIOB_IPEND   (GPIOB_BASE  + 0x7 ) //Interrupt Pending Register
#define GPIOB_IEDGE   (GPIOB_BASE  + 0x8 ) //Interrupt Edge-Sensitive Register
#define GPIOB_PPOUTM  (GPIOB_BASE  + 0x9 ) //Push-Pull Output Mode Control Register
#define GPIOB_RDATA   (GPIOB_BASE  + 0xA ) //Raw Data Input Register
#define GPIOB_DRIVE   (GPIOB_BASE  + 0xB ) //Output Drive Strength Control Register
#define GPIOC_PUPEN   (GPIOC_BASE  + 0x0 ) //Pull-up Enable Register
#define GPIOC_DATA    (GPIOC_BASE  + 0x1 ) //Data Register
#define GPIOC_DDIR    (GPIOC_BASE  + 0x2 ) //Data Direction Register
#define GPIOC_PEREN   (GPIOC_BASE  + 0x3 ) //Peripheral Enable Register
#define GPIOC_IASSRT  (GPIOC_BASE  + 0x4 ) //Interrupt Assert Register
#define GPIOC_IEN     (GPIOC_BASE  + 0x5 ) //Interrupt Enable Register
#define GPIOC_IPOL    (GPIOC_BASE  + 0x6 ) //Interrupt Polarity Register
#define GPIOC_IPEND   (GPIOC_BASE  + 0x7 ) //Interrupt Pending Register
#define GPIOC_IEDGE   (GPIOC_BASE  + 0x8 ) //Interrupt Edge-Sensitive Register
#define GPIOC_PPOUTM  (GPIOC_BASE  + 0x9 ) //Push-Pull Output Mode Control Register
#define GPIOC_RDATA   (GPIOC_BASE  + 0xA ) //Raw Data Input Register
#define GPIOC_DRIVE   (GPIOC_BASE  + 0xB ) //Output Drive Strength Control Register
#define GPIOD_PUPEN   (GPIOD_BASE  + 0x0 ) //Pull-up Enable Register
#define GPIOD_DATA    (GPIOD_BASE  + 0x1 ) //Data Register
#define GPIOD_DDIR    (GPIOD_BASE  + 0x2 ) //Data Direction Register
#define GPIOD_PEREN   (GPIOD_BASE  + 0x3 ) //Peripheral Enable Register
#define GPIOD_IASSRT  (GPIOD_BASE  + 0x4 ) //Interrupt Assert Register
#define GPIOD_IEN     (GPIOD_BASE  + 0x5 ) //Interrupt Enable Register
#define GPIOD_IPOL    (GPIOD_BASE  + 0x6 ) //Interrupt Polarity Register
#define GPIOD_IPEND   (GPIOD_BASE  + 0x7 ) //Interrupt Pending Register
#define GPIOD_IEDGE   (GPIOD_BASE  + 0x8 ) //Interrupt Edge-Sensitive Register
#define GPIOD_PPOUTM  (GPIOD_BASE  + 0x9 ) //Push-Pull Output Mode Control Register
#define GPIOD_RDATA   (GPIOD_BASE  + 0xA ) //Raw Data Input Register
#define GPIOD_DRIVE   (GPIOD_BASE  + 0xB ) //Output Drive Strength Control Register
#define PIT0_CTRL     (PIT0_BASE   + 0x0 ) //Control Register
#define PIT0_MOD      (PIT0_BASE   + 0x1 ) //Modulo Register
#define PIT0_CNTR     (PIT0_BASE   + 0x2 ) //Counter Register
#define PIT1_CTRL     (PIT1_BASE   + 0x0 ) //Control Register
#define PIT1_MOD      (PIT1_BASE   + 0x1 ) //Modulo Register
#define PIT1_CNTR     (PIT1_BASE   + 0x2 ) //Counter Register
#define PIT2_CTRL     (PIT2_BASE   + 0x0 ) //Control Register
#define PIT2_MOD      (PIT2_BASE   + 0x1 ) //Modulo Register
#define PIT2_CNTR     (PIT2_BASE   + 0x2 ) //Counter Register
#define DAC0_CTRL     (DAC0_BASE   + 0x0 ) //Control Register
#define DAC0_DATA     (DAC0_BASE   + 0x1 ) //Data Register
#define DAC0_STEP     (DAC0_BASE   + 0x2 ) //Step Register
#define DAC0_MINVAL   (DAC0_BASE   + 0x3 ) //Minimum Value Register
#define DAC0_MAXVAL   (DAC0_BASE   + 0x4 ) //Maximum Value Register
#define DAC1_CTRL     (DAC1_BASE   + 0x0 ) //Control Register
#define DAC1_DATA     (DAC1_BASE   + 0x1 ) //Data Register
#define DAC1_STEP     (DAC1_BASE   + 0x2 ) //Step Register
#define DAC1_MINVAL   (DAC1_BASE   + 0x3 ) //Minimum Value Register
#define DAC1_MAXVAL   (DAC1_BASE   + 0x4 ) //Maximum Value Register
#define CMPA_CTRL     (CMPA_BASE   + 0x0 ) //Control Register
#define CMPA_STAT     (CMPA_BASE   + 0x1 ) //Status Register
#define CMPA_FILT     (CMPA_BASE   + 0x2 ) //Filter Register
#define CMPB_CTRL     (CMPB_BASE   + 0x0 ) //Control Register
#define CMPB_STAT     (CMPB_BASE   + 0x1 ) //Status Register
#define CMPB_FILT     (CMPB_BASE   + 0x2 ) //Filter Register
#define QSCI0_RATE    (QSCIO0_BASE + 0x0 ) //Baud Rate Register
#define QSCI0_CTRL1   (QSCIO0_BASE + 0x1 ) //Control Register 1
#define QSCI0_CTRL2   (QSCIO0_BASE + 0x2 ) //Control Register 2
#define QSCI0_STAT    (QSCIO0_BASE + 0x3 ) //Status Register
#define QSCI0_DATA    (QSCIO0_BASE + 0x4 ) //Data Register
#define QSCI1_RATE    (QSCIO1_BASE + 0x0 ) //Baud Rate Register
#define QSCI1_CTRL1   (QSCIO1_BASE + 0x1 ) //Control Register 1
#define QSCI1_CTRL2   (QSCIO1_BASE + 0x2 ) //Control Register 2
#define QSCI1_STAT    (QSCIO1_BASE + 0x3 ) //Status Register
#define QSCI1_DATA    (QSCIO1_BASE + 0x4 ) //Data Register
#define QSPI0_SCTRL   (QSPI0_BASE  + 0x0 ) //Status and Control Register
#define QSPI0_DSCTRL  (QSPI0_BASE  + 0x1 ) //Data Size and Control Register
#define QSPI0_DRCV    (QSPI0_BASE  + 0x2 ) //Data Receive Register
#define QSPI0_DXMIT   (QSPI0_BASE  + 0x3 ) //Data Transmit Register
#define QSPI0_FIFO    (QSPI0_BASE  + 0x4 ) //FIFO Control Register
#define QSPI0_DELAY   (QSPI0_BASE  + 0x5 ) //Delay Register
#define QSPI1_SCTRL   (QSPI1_BASE  + 0x0 ) //Status and Control Register
#define QSPI1_DSCTRL  (QSPI1_BASE  + 0x1 ) //Data Size and Control Register
#define QSPI1_DRCV    (QSPI1_BASE  + 0x2 ) //Data Receive Register
#define QSPI1_DXMIT   (QSPI1_BASE  + 0x3 ) //Data Transmit Register
#define QSPI1_FIFO    (QSPI1_BASE  + 0x4 ) //FIFO Control Register
#define QSPI1_DELAY   (QSPI1_BASE  + 0x5 ) //Delay Register
#define I2C_CTRL      (I2C_BASE    + 0x0 ) //Control Register
#define I2C_TAR       (I2C_BASE    + 0x2 ) //Target Address Register
#define I2C_SAR       (I2C_BASE    + 0x4 ) //Slave Address Register
#define I2C_DATA      (I2C_BASE    + 0x8 ) //RX/TX Data Buffer and Command Register
#define I2C_SSHCNT    (I2C_BASE    + 0xA ) //Standard Speed Clock SCL High Count Register
#define I2C_SSLCNT    (I2C_BASE    + 0xC ) //Standard Speed Clock SCL Low Count Register
#define I2C_FSHCNT    (I2C_BASE    + 0xE ) //Fast Speed Clock SCL High Count Register
#define I2C_FSLCNT    (I2C_BASE    + 0x10) //Fast Speed Clock SCL Low Count Register
#define I2C_ISTAT     (I2C_BASE    + 0x16) //Interrupt Status Register
#define I2C_IMASK     (I2C_BASE    + 0x18) //Interrupt Mask Register
#define I2C_RISTAT    (I2C_BASE    + 0x1A) //Raw Interrupt Status Register
#define I2C_RXFT      (I2C_BASE    + 0x1C) //Receive FIFO Threshold Register
#define I2C_TXFT      (I2C_BASE    + 0x1E) //Transmit FIFO Threshold Register
#define I2C_CLRINT    (I2C_BASE    + 0x20) //Clear Combined and Individual Interrupts Register
#define I2C_CLRRXUND  (I2C_BASE    + 0x22) //Clear RX_UNDER Interrupt Register
#define I2C_CLRRXOVR  (I2C_BASE    + 0x24) //Clear RX_OVER Interrupt Register
#define I2C_CLRTXOVR  (I2C_BASE    + 0x26) //Clear TX_OVER Interrupt Register
#define I2C_CLRRDREQ  (I2C_BASE    + 0x28) //Clear RD_REQ Interrupt Register
#define I2C_CLRTXABRT (I2C_BASE    + 0x2A) //Clear TX_ABRT Interrupt Register
#define I2C_CLRRXDONE (I2C_BASE    + 0x2C) //Clear RX_DONE Interrupt Register
#define I2C_CLRACT    (I2C_BASE    + 0x2E) //Clear Activity Interrupt Register
#define I2C_CLRSTPDET (I2C_BASE    + 0x30) //Clear STOP_DET Interrupt Register
#define I2C_CLRSTDET  (I2C_BASE    + 0x32) //Clear START_DET Interrupt Register
#define I2C_CLRGC     (I2C_BASE    + 0x34) //Clear GEN_CALL Interrupt Register
#define I2C_ENBL      (I2C_BASE    + 0x36) //Enable Register
#define I2C_STAT      (I2C_BASE    + 0x38) //Status Register
#define I2C_TXFLR     (I2C_BASE    + 0x3A) //Transmit FIFO Level Register
#define I2C_RXFLR     (I2C_BASE    + 0x3C) //Receive FIFO Level Register
#define I2C_TXABRTSRC (I2C_BASE    + 0x40) //Transmit Abort Status Register
#define FM_CLKDIV     (FM_BASE     + 0x0 ) //Clock Divider Register
#define FM_CNFG       (FM_BASE     + 0x1 ) //Configuration Register
#define FM_SECHI      (FM_BASE     + 0x3 ) //Security High Half Register
#define FM_SECLO      (FM_BASE     + 0x4 ) //Security Low Half Register
#define FM_PROT       (FM_BASE     + 0x10) //Protection Register
#define FM_USTAT      (FM_BASE     + 0x13) //User Status Register
#define FM_CMD        (FM_BASE     + 0x14) //Command Register
#define FM_DATA       (FM_BASE     + 0x18) //Data Buffer Register
#define FM_OPT1       (FM_BASE     + 0x1B) //Information Option Register 1
#define FM_TSTSIG     (FM_BASE     + 0x1D) //Test Array Signature Register
#define MSCAN_CTRL0   (MSCAN_BASE  + 0x00) //Control Register 0
#define MSCAN_CTRL1   (MSCAN_BASE  + 0x01) //Control Register 1
#define MSCAN_BTR0    (MSCAN_BASE  + 0x02) //Bus Timing Register 0
#define MSCAN_BTR1    (MSCAN_BASE  + 0x03) //Bus Timing Register 1
#define MSCAN_RFLG    (MSCAN_BASE  + 0x04) //Receiver Flag Register
#define MSCAN_RIER    (MSCAN_BASE  + 0x05) //Receiver Interrupt Enable Register
#define MSCAN_TFLG    (MSCAN_BASE  + 0x06) //Transmitter Flag Register
#define MSCAN_TIER    (MSCAN_BASE  + 0x07) //Transmitter Interrupt Enable Register
#define MSCAN_TARQ    (MSCAN_BASE  + 0x08) //Transmitter Message Abort Request Register
#define MSCAN_TAAK    (MSCAN_BASE  + 0x09) //Transmitter Message Abort Acknowledge Register
#define MSCAN_TBSEL   (MSCAN_BASE  + 0x0A) //Transmitter Buffer Selection Register
#define MSCAN_IDAC    (MSCAN_BASE  + 0x0B) //Identifier Acceptance Control Register
#define MSCAN_MISC    (MSCAN_BASE  + 0x0D) //Miscellaneous Register
#define MSCAN_RXERR   (MSCAN_BASE  + 0x0E) //Receive Error Register
#define MSCAN_TXERR   (MSCAN_BASE  + 0x0F) //Transmit Error Register
#define MSCAN_IDAR0   (MSCAN_BASE  + 0x10) //Identifier Acceptance Register 0
#define MSCAN_IDAR1   (MSCAN_BASE  + 0x11) //Identifier Acceptance Register 1
#define MSCAN_IDAR2   (MSCAN_BASE  + 0x12) //Identifier Acceptance Register 2
#define MSCAN_IDAR3   (MSCAN_BASE  + 0x13) //Identifier Acceptance Register 3
#define MSCAN_IDMR0   (MSCAN_BASE  + 0x14) //Identifier Mask Register 0
#define MSCAN_IDMR1   (MSCAN_BASE  + 0x15) //Identifier Mask Register 1
#define MSCAN_IDMR2   (MSCAN_BASE  + 0x16) //Identifier Mask Register 2
#define MSCAN_IDMR3   (MSCAN_BASE  + 0x17) //Identifier Mask Register 3
#define MSCAN_IDAR4   (MSCAN_BASE  + 0x18) //Identifier Acceptance Register 4
#define MSCAN_IDAR5   (MSCAN_BASE  + 0x19) //Identifier Acceptance Register 5
#define MSCAN_IDAR6   (MSCAN_BASE  + 0x1A) //Identifier Acceptance Register 6
#define MSCAN_IDAR7   (MSCAN_BASE  + 0x1B) //Identifier Acceptance Register 7
#define MSCAN_IDMR4   (MSCAN_BASE  + 0x1C) //Identifier Mask Register 4
#define MSCAN_IDMR5   (MSCAN_BASE  + 0x1D) //Identifier Mask Register 5
#define MSCAN_IDMR6   (MSCAN_BASE  + 0x1E) //Identifier Mask Register 6
#define MSCAN_IDMR7   (MSCAN_BASE  + 0x1F) //Identifier Mask Register 7
#define MSCAN_RXFG0   (MSCAN_BASE  + 0x20) //Foreground Receive Buffer 0
#define MSCAN_RXFG1   (MSCAN_BASE  + 0x21) //Foreground Receive Buffer 1
#define MSCAN_RXFG2   (MSCAN_BASE  + 0x22) //Foreground Receive Buffer 2
#define MSCAN_RXFG3   (MSCAN_BASE  + 0x23) //Foreground Receive Buffer 3
#define MSCAN_RXFG4   (MSCAN_BASE  + 0x24) //Foreground Receive Buffer 4
#define MSCAN_RXFG5   (MSCAN_BASE  + 0x25) //Foreground Receive Buffer 5
#define MSCAN_RXFG6   (MSCAN_BASE  + 0x26) //Foreground Receive Buffer 6
#define MSCAN_RXFG7   (MSCAN_BASE  + 0x27) //Foreground Receive Buffer 7
#define MSCAN_RXFG8   (MSCAN_BASE  + 0x28) //Foreground Receive Buffer 8
#define MSCAN_RXFG9   (MSCAN_BASE  + 0x29) //Foreground Receive Buffer 9
#define MSCAN_RXFG10  (MSCAN_BASE  + 0x2A) //Foreground Receive Buffer 10
#define MSCAN_RXFG11  (MSCAN_BASE  + 0x2B) //Foreground Receive Buffer 11
#define MSCAN_RXFG12  (MSCAN_BASE  + 0x2C) //Foreground Receive Buffer 12
#define MSCAN_RXFG13  (MSCAN_BASE  + 0x2D) //Foreground Receive Buffer 13
#define MSCAN_RXFG14  (MSCAN_BASE  + 0x2E) //Foreground Receive Buffer 14
#define MSCAN_RXFG15  (MSCAN_BASE  + 0x2F) //Foreground Receive Buffer 15
#define MSCAN_TXFG0   (MSCAN_BASE  + 0x30) //Foreground Transmit Buffer 0
#define MSCAN_TXFG1   (MSCAN_BASE  + 0x31) //Foreground Transmit Buffer 1
#define MSCAN_TXFG2   (MSCAN_BASE  + 0x32) //Foreground Transmit Buffer 2
#define MSCAN_TXFG3   (MSCAN_BASE  + 0x33) //Foreground Transmit Buffer 3
#define MSCAN_TXFG4   (MSCAN_BASE  + 0x34) //Foreground Transmit Buffer 4
#define MSCAN_TXFG5   (MSCAN_BASE  + 0x35) //Foreground Transmit Buffer 5
#define MSCAN_TXFG6   (MSCAN_BASE  + 0x36) //Foreground Transmit Buffer 6
#define MSCAN_TXFG7   (MSCAN_BASE  + 0x37) //Foreground Transmit Buffer 7
#define MSCAN_TXFG8   (MSCAN_BASE  + 0x38) //Foreground Transmit Buffer 8
#define MSCAN_TXFG9   (MSCAN_BASE  + 0x39) //Foreground Transmit Buffer 9
#define MSCAN_TXFG10  (MSCAN_BASE  + 0x3A) //Foreground Transmit Buffer 10
#define MSCAN_TXFG11  (MSCAN_BASE  + 0x3B) //Foreground Transmit Buffer 11
#define MSCAN_TXFG12  (MSCAN_BASE  + 0x3C) //Foreground Transmit Buffer 12
#define MSCAN_TXFG13  (MSCAN_BASE  + 0x3D) //Foreground Transmit Buffer 13
#define MSCAN_TXFG14  (MSCAN_BASE  + 0x3E) //Foreground Transmit Buffer 14
#define MSCAN_TXFG15  (MSCAN_BASE  + 0x3F) //Foreground Transmit Buffer 15
