#ifndef _DEBUG_H_
#define _DEBUG_H_

#define BOOL			unsigned char
#define BYTE			unsigned char
#define WORD			unsigned short
#define DWORD			unsigned long

#define TRUE			1
#define FALSE			0

#define PWORD(x)		(*(unsigned volatile short*)(x))
#define PLONG(x)		(*(unsigned volatile long*)(x))

#define SCI0_BASE	0x1300
#define SCI0_BR			PWORD(SCI0_BASE + 0)
#define SCI0_CR			PWORD(SCI0_BASE + 1)
#define SCI0_SR			PWORD(SCI0_BASE + 2)
#define SCI0_DR			PWORD(SCI0_BASE + 3)

#define IPR				PWORD(0xFFFB)

#define ITCN_BASE	0x1260
#define ITCN_GPR12		PWORD(ITCN_BASE + 0xc)
#define ITCN_GPR13		PWORD(ITCN_BASE + 0xd)

#define GPIO_E_PER		PWORD(0x13F3)



#define MON_BUFF_SIZE		100

#define SCI0_TX_START		SCI0_CR |= 0x0080
#define SCI0_TX_STOP		SCI0_CR &= 0xFF7F

#define START_CHAR          0x3A
#define END_CHAR            0x0D
#define NAK_CHAR            0x3F
#define ASC_HEX_ERROR       0xFF	


extern BYTE asc2hex(BYTE asc);
extern BYTE hex2asc(BYTE hex);
extern void push_tx_buff(char c);
extern void push_tx_buff_hex(BYTE h);
extern void InitDebug();
extern void SCI0_RX_FULL(void);
extern void SCI0_TX_EMPTY(void);

#endif