



/*  metrowerks sample code  */



/*
	this source illustrates code called by ISR 
	and #pragma directives necessary for ISR-safe code
		
*/



#include "DSP56F807.h"
#include "led.h"

/* libraries called by interrupt handlers need this pragma, it will:
1. save used register
2. return with RTS instead of RTI */
#pragma interrupt called

void initLED()
{
	/* disable SSI peripheral */
	asm(bfclr	#$0001,X:GPIO_D_PER);
	
	/* output direction */
	asm(bfset	#$0001,X:GPIO_D_DDR);
	
	/* off at first */
	asm(bfclr	#$0001,X:GPIO_D_DR);
}

/* libraries called by interrupt handlers need this pragma, it will:
1. save used register
2. return with RTS instead of RTI */
#pragma interrupt called

void onLED(int element)
{
	switch (element)
	{
		case 1:
			asm(bfset	#$0001,X:GPIO_D_DR);
			break;
		default:
			asm(debug);	/* not a graceful error handling, just freeze */
			break;
	}
}

/* libraries called by interrupt handlers need this pragma, it will:
1. save used register
2. return with RTS instead of RTI */
#pragma interrupt called

void offLED(int element)
{
	switch (element)
	{
		case 1:
			asm(bfclr	#$0001,X:GPIO_D_DR);
			break;
		default:
			asm(debug);	/* not a graceful error handling, just freeze */
			break;
	}
}

/* libraries called by interrupt handlers need this pragma, it will:
1. save used register
2. return with RTS instead of RTI */
#pragma interrupt called

void toggleLED(int element)
{
	switch (element)
	{
		case 1:
			asm(bfchg	#$0001,X:GPIO_D_DR);
			break;
		default:
			asm(debug);	/* not a graceful error handling, just freeze */
			break;
	}
}