



/*  metrowerks sample code  */



/*
	this source illustrates code called by ISR 
	and #pragma directives necessary for ISR-safe code		
*/

/*	
	main program creates a timer compare interrupt 
	to blink EVM LEDs; pushing IRQA/B will switch LED group.

    IRQA corresponds to LED 1
	IRQB corresponds to LED 3
	
	to boot in standalone mode from flash:
	1. disconnect parallel cable & power cable
	2. power down
	3. power on
	
*/



#include <stdlib.h>
#include "led.h"
#include "isr.h"
#include "Debug.h"

int main(void)
{
	initLED ();
	initIsr (); 
	InitDebug();
	
	while (1)
	{
		/* press IRQA/IRQB to decide LED group */
		asm(nop);
		asm(nop);
		asm(nop);
		asm(nop);
		asm(nop);
		asm(nop);
	}
	
	exit(0);  /* Call Exit to flush all IO buffers */
}
