#ifndef _DEBUG_H_
#define _DEBUG_H_

#define BOOL			unsigned char
#define BYTE			unsigned char
#define WORD			unsigned short
#define DWORD			unsigned long

#define TRUE			1
#define FALSE			0

#define PWORD(x)		(*(unsigned volatile short*)(x))
#define PLONG(x)		(*(unsigned volatile long*)(x))

#define GPIOE_BASE 0x00F330

#define GPIO_E_RAWDATA	PWORD(GPIOE_BASE + 0xA)
#define GPIO_E_PPMODE   PWORD(GPIOE_BASE + 0x9)
#define GPIO_E_IESR		PWORD(GPIOE_BASE + 0x8)
#define GPIO_E_IPR		PWORD(GPIOE_BASE + 0x7)
#define GPIO_E_IPOLR	PWORD(GPIOE_BASE + 0x6)
#define GPIO_E_IENR		PWORD(GPIOE_BASE + 0x5)
#define GPIO_E_IAR		PWORD(GPIOE_BASE + 0x4)
#define GPIO_E_PER		PWORD(GPIOE_BASE + 0x3)
#define GPIO_E_DDR		PWORD(GPIOE_BASE + 0x2)
#define GPIO_E_DR		PWORD(GPIOE_BASE + 0x1)
#define GPIO_E_PUR		PWORD(GPIOE_BASE + 0x0)

#define SCI0_BASE 0x00F280

#define SCI0_DR			PWORD(SCI0_BASE + 4)
#define SCI0_SR			PWORD(SCI0_BASE + 3)
#define SCI0_CR			PWORD(SCI0_BASE + 1)
#define SCI0_BR			PWORD(SCI0_BASE + 0)

#define INTC_IPR8       PWORD(0x0000F1A8)



#define MON_BUFF_SIZE		100

#define SCI0_TX_START		SCI0_CR |= 0x0080
#define SCI0_TX_STOP		SCI0_CR &= 0xFF7F

#define START_CHAR          0x3A
#define END_CHAR            0x0D
#define NAK_CHAR            0x3F
#define ASC_HEX_ERROR       0xFF	


extern BYTE asc2hex(BYTE asc);
extern BYTE hex2asc(BYTE hex);
extern void push_tx_buff(char c);
extern void push_tx_buff_hex(BYTE h);
extern void InitDebug();
extern void SCI0_RX_FULL(void);
extern void SCI0_TX_EMPTY(void);

#endif