



/*  metrowerks sample code  */



#define OESCR		0xFFFF8A
#define OBCNTR		0xFFFF8E
#define OBMSK		0xFFFF90
#define OBAR2		0xFFFF92
#define OBAR1		0xFFFF94
#define OBCR		0xFFFF96
#define OTB			0xFFFF9B
#define OTBPR		0xFFFF9A
#define OTBCR		0xFFFF9B
#define OBASE		0xFFFF9C
#define OSR			0xFFFF9D
#define OSCNTR		0xFFFF9E
#define OCR			0xFFFFA0
#define OCLSR		0xFFFFFC
#define OTXRXSR		0xFFFFFD
#define OTX_ORX		0xFFFFFE
#define OTX1_ORX1	0xFFFFFF

// High Level Peripheral Memory Interface
#define   EMI_BASE        0xF020     //  External Memory Interface
#define   TMRA_BASE       0xF040     //  Timer A
#define   TMRB_BASE       0xF080     //  Timer B
#define   TMRC_BASE       0xF0C0     //  Timer C
#define   TMRD_BASE       0xF100     //  Timer D
#define   PWMA_BASE       0xF140     //  PWM A
#define   PWMB_BASE       0xF160     //  PWM B
#define   DEC0_BASE       0xF180     //  Quadrature Decoder 0
#define   DEC1_BASE       0xF190     //  Quadrature Decoder 1
#define   ITCN_BASE       0xF1A0     //  ITCN
#define   ADCA_BASE       0xF200     //  ADC A
#define   ADCB_BASE       0xF240     //  ADC B
#define   TSENSOR_BASE    0xF270     //  Temperature Sensor
#define   SCI0_BASE       0xF280     //  SCI #0
#define   SCI1_BASE       0xF290     //  SCI #1
#define   SPI0_BASE       0xF2A0     //  SPI #0
#define   SPI1_BASE       0xF2B0     //  SPI #1
#define   COP_BASE        0xF2C0     //  COP
#define   CLKGEN_BASE     0xF2D0     //  PLL, OSC
#define   GPIOA_BASE      0xF2E0     //  GPIO Port A
#define   GPIOB_BASE      0xF300     //  GPIO Port B
#define   GPIOC_BASE      0xF310     //  GPIO Port C
#define   GPIOD_BASE      0xF320     //  GPIO Port D
#define   GPIOE_BASE      0xF330     //  GPIO Port E
#define   GPIOF_BASE      0xF340     //  GPIO Port F
#define   SIM_BASE        0xF350     //  SIM
#define   LVI_BASE        0xF360     //  Power Supervisor
#define   FM_BASE         0xF400     //  FM
#define   FC_BASE         0xF800     //  FlexCAN
#define   FC2_BASE        0xFA00     //  FlexCAN2


#define  CSBAR0                 ( EMI_BASE      + 0x0  )  //Chip Select Base Address Register 0
#define  CSBAR1                 ( EMI_BASE      + 0x1  )  //Chip Select Base Address Register 1
#define  CSBAR2                 ( EMI_BASE      + 0x2  )  //Chip Select Base Address Register 2
#define  CSBAR3                 ( EMI_BASE      + 0x3  )  //Chip Select Base Address Register 3
#define  CSBAR4                 ( EMI_BASE      + 0x4  )  //Chip Select Base Address Register 4
#define  CSBAR5                 ( EMI_BASE      + 0x5  )  //Chip Select Base Address Register 5
#define  CSBAR6                 ( EMI_BASE      + 0x6  )  //Chip Select Base Address Register 6
#define  CSBAR7                 ( EMI_BASE      + 0x7  )  //Chip Select Base Address Register 7
#define  CSOR0                  ( EMI_BASE      + 0x8  )  //Chip Select Option Register 0
#define  CSOR1                  ( EMI_BASE      + 0x9  )  //Chip Select Option Register 1
#define  CSOR2                  ( EMI_BASE      + 0xA  )  //Chip Select Option Register 2
#define  CSOR3                  ( EMI_BASE      + 0xB  )  //Chip Select Option Register 3
#define  CSOR4                  ( EMI_BASE      + 0xC  )  //Chip Select Option Register 4
#define  CSOR5                  ( EMI_BASE      + 0xD  )  //Chip Select Option Register 5
#define  CSOR6                  ( EMI_BASE      + 0xE  )  //Chip Select Option Register 6
#define  CSOR7                  ( EMI_BASE      + 0xF  )  //Chip Select Option Register 7
#define  CSTC0                  ( EMI_BASE      + 0x10 )  //Chip Select Timing Control Register 0
#define  CSTC1                  ( EMI_BASE      + 0x11 )  //Chip Select Timing Control Register 1
#define  CSTC2                  ( EMI_BASE      + 0x12 )  //Chip Select Timing Control Register 2
#define  CSTC3                  ( EMI_BASE      + 0x13 )  //Chip Select Timing Control Register 3
#define  CSTC4                  ( EMI_BASE      + 0x14 )  //Chip Select Timing Control Register 4
#define  CSTC5                  ( EMI_BASE      + 0x15 )  //Chip Select Timing Control Register 5
#define  CSTC6                  ( EMI_BASE      + 0x16 )  //Chip Select Timing Control Register 6
#define  CSTC7                  ( EMI_BASE      + 0x17 )  //Chip Select Timing Control Register 7
#define  BCR                    ( EMI_BASE      + 0x18 )  //Bus Control Register
#define  TMRA0_CMP1             ( TMRA_BASE     + 0x0  )  //Compare Register 1
#define  TMRA0_CMP2             ( TMRA_BASE     + 0x1  )  //Compare Register 2
#define  TMRA0_CAP              ( TMRA_BASE     + 0x2  )  //Capture Register
#define  TMRA0_LOAD             ( TMRA_BASE     + 0x3  )  //Load Register
#define  TMRA0_HOLD             ( TMRA_BASE     + 0x4  )  //Hold Register
#define  TMRA0_CNTR             ( TMRA_BASE     + 0x5  )  //Counter Register
#define  TMRA0_CTRL             ( TMRA_BASE     + 0x6  )  //Control Register
#define  TMRA0_SCR              ( TMRA_BASE     + 0x7  )  //Status and Control Register
#define  TMRA0_CMPLD1           ( TMRA_BASE     + 0x8  )  //Comparator Load Register 1
#define  TMRA0_CMPLD2           ( TMRA_BASE     + 0x9  )  //Comparator Load Register 2
#define  TMRA0_COMSCR           ( TMRA_BASE     + 0xA  )  //Comparator Status and Control Register
#define  TMRA1_CMP1             ( TMRA_BASE     + 0x10 )  //Compare Register 1
#define  TMRA1_CMP2             ( TMRA_BASE     + 0x11 )  //Compare Register 2
#define  TMRA1_CAP              ( TMRA_BASE     + 0x12 )  //Capture Register
#define  TMRA1_LOAD             ( TMRA_BASE     + 0x13 )  //Load Register
#define  TMRA1_HOLD             ( TMRA_BASE     + 0x14 )  //Hold Register
#define  TMRA1_CNTR             ( TMRA_BASE     + 0x15 )  //Counter Register
#define  TMRA1_CTRL             ( TMRA_BASE     + 0x16 )  //Control Register
#define  TMRA1_SCR              ( TMRA_BASE     + 0x17 )  //Status and Control Register
#define  TMRA1_CMPLD1           ( TMRA_BASE     + 0x18 )  //Comparator Load Register 1
#define  TMRA1_CMPLD2           ( TMRA_BASE     + 0x19 )  //Comparator Load Register 2
#define  TMRA1_COMSCR           ( TMRA_BASE     + 0x1A )  //Comparator Status and Control Register
#define  TMRA2_CMP1             ( TMRA_BASE     + 0x20 )  //Compare Register 1
#define  TMRA2_CMP2             ( TMRA_BASE     + 0x21 )  //Compare Register 2
#define  TMRA2_CAP              ( TMRA_BASE     + 0x22 )  //Capture Register
#define  TMRA2_LOAD             ( TMRA_BASE     + 0x23 )  //Load Register
#define  TMRA2_HOLD             ( TMRA_BASE     + 0x24 )  //Hold Register
#define  TMRA2_CNTR             ( TMRA_BASE     + 0x25 )  //Counter Register
#define  TMRA2_CTRL             ( TMRA_BASE     + 0x26 )  //Control Register
#define  TMRA2_SCR              ( TMRA_BASE     + 0x27 )  //Status and Control Register
#define  TMRA2_CMPLD1           ( TMRA_BASE     + 0x28 )  //Comparator Load Register 1
#define  TMRA2_CMPLD2           ( TMRA_BASE     + 0x29 )  //Comparator Load Register 2
#define  TMRA2_COMSCR           ( TMRA_BASE     + 0x2A )  //Comparator Status and Control Register
#define  TMRA3_CMP1             ( TMRA_BASE     + 0x30 )  //Compare Register 1
#define  TMRA3_CMP2             ( TMRA_BASE     + 0x31 )  //Compare Register 2
#define  TMRA3_CAP              ( TMRA_BASE     + 0x32 )  //Capture Register
#define  TMRA3_LOAD             ( TMRA_BASE     + 0x33 )  //Load Register
#define  TMRA3_HOLD             ( TMRA_BASE     + 0x34 )  //Hold Register
#define  TMRA3_CNTR             ( TMRA_BASE     + 0x35 )  //Counter Register
#define  TMRA3_CTRL             ( TMRA_BASE     + 0x36 )  //Control Register
#define  TMRA3_SCR              ( TMRA_BASE     + 0x37 )  //Status and Control Register
#define  TMRA3_CMPLD1           ( TMRA_BASE     + 0x38 )  //Comparator Load Register 1
#define  TMRA3_CMPLD2           ( TMRA_BASE     + 0x39 )  //Comparator Load Register 2
#define  TMRA3_COMSCR           ( TMRA_BASE     + 0x3A )  //Comparator Status and Control Register
#define  TMRB0_CMP1             ( TMRB_BASE     + 0x0  )  //Compare Register 1
#define  TMRB0_CMP2             ( TMRB_BASE     + 0x1  )  //Compare Register 2
#define  TMRB0_CAP              ( TMRB_BASE     + 0x2  )  //Capture Register
#define  TMRB0_LOAD             ( TMRB_BASE     + 0x3  )  //Load Register
#define  TMRB0_HOLD             ( TMRB_BASE     + 0x4  )  //Hold Register
#define  TMRB0_CNTR             ( TMRB_BASE     + 0x5  )  //Counter Register
#define  TMRB0_CTRL             ( TMRB_BASE     + 0x6  )  //Control Register
#define  TMRB0_SCR              ( TMRB_BASE     + 0x7  )  //Status and Control Register
#define  TMRB0_CMPLD1           ( TMRB_BASE     + 0x8  )  //Comparator Load Register 1
#define  TMRB0_CMPLD2           ( TMRB_BASE     + 0x9  )  //Comparator Load Register 2
#define  TMRB0_COMSCR           ( TMRB_BASE     + 0xA  )  //Comparator Status and Control Register
#define  TMRB1_CMP1             ( TMRB_BASE     + 0x10 )  //Compare Register 1
#define  TMRB1_CMP2             ( TMRB_BASE     + 0x11 )  //Compare Register 2
#define  TMRB1_CAP              ( TMRB_BASE     + 0x12 )  //Capture Register
#define  TMRB1_LOAD             ( TMRB_BASE     + 0x13 )  //Load Register
#define  TMRB1_HOLD             ( TMRB_BASE     + 0x14 )  //Hold Register
#define  TMRB1_CNTR             ( TMRB_BASE     + 0x15 )  //Counter Register
#define  TMRB1_CTRL             ( TMRB_BASE     + 0x16 )  //Control Register
#define  TMRB1_SCR              ( TMRB_BASE     + 0x17 )  //Status and Control Register
#define  TMRB1_CMPLD1           ( TMRB_BASE     + 0x18 )  //Comparator Load Register 1
#define  TMRB1_CMPLD2           ( TMRB_BASE     + 0x19 )  //Comparator Load Register 2
#define  TMRB1_COMSCR           ( TMRB_BASE     + 0x1A )  //Comparator Status and Control Register
#define  TMRB2_CMP1             ( TMRB_BASE     + 0x20 )  //Compare Register 1
#define  TMRB2_CMP2             ( TMRB_BASE     + 0x21 )  //Compare Register 2
#define  TMRB2_CAP              ( TMRB_BASE     + 0x22 )  //Capture Register
#define  TMRB2_LOAD             ( TMRB_BASE     + 0x23 )  //Load Register
#define  TMRB2_HOLD             ( TMRB_BASE     + 0x24 )  //Hold Register
#define  TMRB2_CNTR             ( TMRB_BASE     + 0x25 )  //Counter Register
#define  TMRB2_CTRL             ( TMRB_BASE     + 0x26 )  //Control Register
#define  TMRB2_SCR              ( TMRB_BASE     + 0x27 )  //Status and Control Register
#define  TMRB2_CMPLD1           ( TMRB_BASE     + 0x28 )  //Comparator Load Register 1
#define  TMRB2_CMPLD2           ( TMRB_BASE     + 0x29 )  //Comparator Load Register 2
#define  TMRB2_COMSCR           ( TMRB_BASE     + 0x2A )  //Comparator Status and Control Register
#define  TMRB3_CMP1             ( TMRB_BASE     + 0x30 )  //Compare Register 1
#define  TMRB3_CMP2             ( TMRB_BASE     + 0x31 )  //Compare Register 2
#define  TMRB3_CAP              ( TMRB_BASE     + 0x32 )  //Capture Register
#define  TMRB3_LOAD             ( TMRB_BASE     + 0x33 )  //Load Register
#define  TMRB3_HOLD             ( TMRB_BASE     + 0x34 )  //Hold Register
#define  TMRB3_CNTR             ( TMRB_BASE     + 0x35 )  //Counter Register
#define  TMRB3_CTRL             ( TMRB_BASE     + 0x36 )  //Control Register
#define  TMRB3_SCR              ( TMRB_BASE     + 0x37 )  //Status and Control Register
#define  TMRB3_CMPLD1           ( TMRB_BASE     + 0x38 )  //Comparator Load Register 1
#define  TMRB3_CMPLD2           ( TMRB_BASE     + 0x39 )  //Comparator Load Register 2
#define  TMRB3_COMSCR           ( TMRB_BASE     + 0x3A )  //Comparator Status and Control Register
#define  TMRC0_CMP1             ( TMRC_BASE     + 0x0  )  //Compare Register 1
#define  TMRC0_CMP2             ( TMRC_BASE     + 0x1  )  //Compare Register 2
#define  TMRC0_CAP              ( TMRC_BASE     + 0x2  )  //Capture Register
#define  TMRC0_LOAD             ( TMRC_BASE     + 0x3  )  //Load Register
#define  TMRC0_HOLD             ( TMRC_BASE     + 0x4  )  //Hold Register
#define  TMRC0_CNTR             ( TMRC_BASE     + 0x5  )  //Counter Register
#define  TMRC0_CTRL             ( TMRC_BASE     + 0x6  )  //Control Register
#define  TMRC0_SCR              ( TMRC_BASE     + 0x7  )  //Status and Control Register
#define  TMRC0_CMPLD1           ( TMRC_BASE     + 0x8  )  //Comparator Load Register 1
#define  TMRC0_CMPLD2           ( TMRC_BASE     + 0x9  )  //Comparator Load Register 2
#define  TMRC0_COMSCR           ( TMRC_BASE     + 0xA  )  //Comparator Status and Control Register
#define  TMRC1_CMP1             ( TMRC_BASE     + 0x10 )  //Compare Register 1
#define  TMRC1_CMP2             ( TMRC_BASE     + 0x11 )  //Compare Register 2
#define  TMRC1_CAP              ( TMRC_BASE     + 0x12 )  //Capture Register
#define  TMRC1_LOAD             ( TMRC_BASE     + 0x13 )  //Load Register
#define  TMRC1_HOLD             ( TMRC_BASE     + 0x14 )  //Hold Register
#define  TMRC1_CNTR             ( TMRC_BASE     + 0x15 )  //Counter Register
#define  TMRC1_CTRL             ( TMRC_BASE     + 0x16 )  //Control Register
#define  TMRC1_SCR              ( TMRC_BASE     + 0x17 )  //Status and Control Register
#define  TMRC1_CMPLD1           ( TMRC_BASE     + 0x18 )  //Comparator Load Register 1
#define  TMRC1_CMPLD2           ( TMRC_BASE     + 0x19 )  //Comparator Load Register 2
#define  TMRC1_COMSCR           ( TMRC_BASE     + 0x1A )  //Comparator Status and Control Register
#define  TMRC2_CMP1             ( TMRC_BASE     + 0x20 )  //Compare Register 1
#define  TMRC2_CMP2             ( TMRC_BASE     + 0x21 )  //Compare Register 2
#define  TMRC2_CAP              ( TMRC_BASE     + 0x22 )  //Capture Register
#define  TMRC2_LOAD             ( TMRC_BASE     + 0x23 )  //Load Register
#define  TMRC2_HOLD             ( TMRC_BASE     + 0x24 )  //Hold Register
#define  TMRC2_CNTR             ( TMRC_BASE     + 0x25 )  //Counter Register
#define  TMRC2_CTRL             ( TMRC_BASE     + 0x26 )  //Control Register
#define  TMRC2_SCR              ( TMRC_BASE     + 0x27 )  //Status and Control Register
#define  TMRC2_CMPLD1           ( TMRC_BASE     + 0x28 )  //Comparator Load Register 1
#define  TMRC2_CMPLD2           ( TMRC_BASE     + 0x29 )  //Comparator Load Register 2
#define  TMRC2_COMSCR           ( TMRC_BASE     + 0x2A )  //Comparator Status and Control Register
#define  TMRC3_CMP1             ( TMRC_BASE     + 0x30 )  //Compare Register 1
#define  TMRC3_CMP2             ( TMRC_BASE     + 0x31 )  //Compare Register 2
#define  TMRC3_CAP              ( TMRC_BASE     + 0x32 )  //Capture Register
#define  TMRC3_LOAD             ( TMRC_BASE     + 0x33 )  //Load Register
#define  TMRC3_HOLD             ( TMRC_BASE     + 0x34 )  //Hold Register
#define  TMRC3_CNTR             ( TMRC_BASE     + 0x35 )  //Counter Register
#define  TMRC3_CTRL             ( TMRC_BASE     + 0x36 )  //Control Register
#define  TMRC3_SCR              ( TMRC_BASE     + 0x37 )  //Status and Control Register
#define  TMRC3_CMPLD1           ( TMRC_BASE     + 0x38 )  //Comparator Load Register 1
#define  TMRC3_CMPLD2           ( TMRC_BASE     + 0x39 )  //Comparator Load Register 2
#define  TMRC3_COMSCR           ( TMRC_BASE     + 0x3A )  //Comparator Status and Control Register
#define  TMRD0_CMP1             ( TMRD_BASE     + 0x0  )  //Compare Register 1
#define  TMRD0_CMP2             ( TMRD_BASE     + 0x1  )  //Compare Register 2
#define  TMRD0_CAP              ( TMRD_BASE     + 0x2  )  //Capture Register
#define  TMRD0_LOAD             ( TMRD_BASE     + 0x3  )  //Load Register
#define  TMRD0_HOLD             ( TMRD_BASE     + 0x4  )  //Hold Register
#define  TMRD0_CNTR             ( TMRD_BASE     + 0x5  )  //Counter Register
#define  TMRD0_CTRL             ( TMRD_BASE     + 0x6  )  //Control Register
#define  TMRD0_SCR              ( TMRD_BASE     + 0x7  )  //Status and Control Register
#define  TMRD0_CMPLD1           ( TMRD_BASE     + 0x8  )  //Comparator Load Register 1
#define  TMRD0_CMPLD2           ( TMRD_BASE     + 0x9  )  //Comparator Load Register 2
#define  TMRD0_COMSCR           ( TMRD_BASE     + 0xA  )  //Comparator Status and Control Register
#define  TMRD1_CMP1             ( TMRD_BASE     + 0x10 )  //Compare Register 1
#define  TMRD1_CMP2             ( TMRD_BASE     + 0x11 )  //Compare Register 2
#define  TMRD1_CAP              ( TMRD_BASE     + 0x12 )  //Capture Register
#define  TMRD1_LOAD             ( TMRD_BASE     + 0x13 )  //Load Register
#define  TMRD1_HOLD             ( TMRD_BASE     + 0x14 )  //Hold Register
#define  TMRD1_CNTR             ( TMRD_BASE     + 0x15 )  //Counter Register
#define  TMRD1_CTRL             ( TMRD_BASE     + 0x16 )  //Control Register
#define  TMRD1_SCR              ( TMRD_BASE     + 0x17 )  //Status and Control Register
#define  TMRD1_CMPLD1           ( TMRD_BASE     + 0x18 )  //Comparator Load Register 1
#define  TMRD1_CMPLD2           ( TMRD_BASE     + 0x19 )  //Comparator Load Register 2
#define  TMRD1_COMSCR           ( TMRD_BASE     + 0x1A )  //Comparator Status and Control Register
#define  TMRD2_CMP1             ( TMRD_BASE     + 0x20 )  //Compare Register 1
#define  TMRD2_CMP2             ( TMRD_BASE     + 0x21 )  //Compare Register 2
#define  TMRD2_CAP              ( TMRD_BASE     + 0x22 )  //Capture Register
#define  TMRD2_LOAD             ( TMRD_BASE     + 0x23 )  //Load Register
#define  TMRD2_HOLD             ( TMRD_BASE     + 0x24 )  //Hold Register
#define  TMRD2_CNTR             ( TMRD_BASE     + 0x25 )  //Counter Register
#define  TMRD2_CTRL             ( TMRD_BASE     + 0x26 )  //Control Register
#define  TMRD2_SCR              ( TMRD_BASE     + 0x27 )  //Status and Control Register
#define  TMRD2_CMPLD1           ( TMRD_BASE     + 0x28 )  //Comparator Load Register 1
#define  TMRD2_CMPLD2           ( TMRD_BASE     + 0x29 )  //Comparator Load Register 2
#define  TMRD2_COMSCR           ( TMRD_BASE     + 0x2A )  //Comparator Status and Control Register
#define  TMRD3_CMP1             ( TMRD_BASE     + 0x30 )  //Compare Register 1
#define  TMRD3_CMP2             ( TMRD_BASE     + 0x31 )  //Compare Register 2
#define  TMRD3_CAP              ( TMRD_BASE     + 0x32 )  //Capture Register
#define  TMRD3_LOAD             ( TMRD_BASE     + 0x33 )  //Load Register
#define  TMRD3_HOLD             ( TMRD_BASE     + 0x34 )  //Hold Register
#define  TMRD3_CNTR             ( TMRD_BASE     + 0x35 )  //Counter Register
#define  TMRD3_CTRL             ( TMRD_BASE     + 0x36 )  //Control Register
#define  TMRD3_SCR              ( TMRD_BASE     + 0x37 )  //Status and Control Register
#define  TMRD3_CMPLD1           ( TMRD_BASE     + 0x38 )  //Comparator Load Register 1
#define  TMRD3_CMPLD2           ( TMRD_BASE     + 0x39 )  //Comparator Load Register 2
#define  TMRD3_COMSCR           ( TMRD_BASE     + 0x3A )  //Comparator Status and Control Register
#define  PWMA_PMCTL             ( PWMA_BASE     + 0x0  )  //Control Register
#define  PWMA_PMFCTL            ( PWMA_BASE     + 0x1  )  //Fault Control Register
#define  PWMA_PMFSA             ( PWMA_BASE     + 0x2  )  //Fault Status Acknowledge Register
#define  PWMA_PMOUT             ( PWMA_BASE     + 0x3  )  //Output Control Register
#define  PWMA_PMCNT             ( PWMA_BASE     + 0x4  )  //Counter Register
#define  PWMA_PWMCM             ( PWMA_BASE     + 0x5  )  //Counter Modulo Register
#define  PWMA_PWMVAL0           ( PWMA_BASE     + 0x6  )  //Value Register 0
#define  PWMA_PWMVAL1           ( PWMA_BASE     + 0x7  )  //Value Register 1
#define  PWMA_PWMVAL2           ( PWMA_BASE     + 0x8  )  //Value Register 2
#define  PWMA_PWMVAL3           ( PWMA_BASE     + 0x9  )  //Value Register 3
#define  PWMA_PWMVAL4           ( PWMA_BASE     + 0xA  )  //Value Register 4
#define  PWMA_PWMVAL5           ( PWMA_BASE     + 0xB  )  //Value Register 5
#define  PWMA_PMDEADTM          ( PWMA_BASE     + 0xC  )  //Dead Time Register
#define  PWMA_PMDISMAP1         ( PWMA_BASE     + 0xD  )  //Disable Mapping Register 1
#define  PWMA_PMDISMAP2         ( PWMA_BASE     + 0xE  )  //Disable Mapping Register 2
#define  PWMA_PMCFG             ( PWMA_BASE     + 0xF  )  //Configure Register
#define  PWMA_PMCCR             ( PWMA_BASE     + 0x10 )  //Channel Control Register
#define  PWMA_PMPORT            ( PWMA_BASE     + 0x11 )  //Port Register
#define  PWMA_PMICCR            ( PWMA_BASE     + 0x12 )  //PWM Internal Correction Control Register
#define  PWMB_PMCTL             ( PWMB_BASE     + 0x0  )  //Control Register
#define  PWMB_PMFCTL            ( PWMB_BASE     + 0x1  )  //Fault Control Register
#define  PWMB_PMFSA             ( PWMB_BASE     + 0x2  )  //Fault Status Acknowledge Register
#define  PWMB_PMOUT             ( PWMB_BASE     + 0x3  )  //Output Control Register
#define  PWMB_PMCNT             ( PWMB_BASE     + 0x4  )  //Counter Register
#define  PWMB_PWMCM             ( PWMB_BASE     + 0x5  )  //Counter Modulo Register
#define  PWMB_PWMVAL0           ( PWMB_BASE     + 0x6  )  //Value Register 0
#define  PWMB_PWMVAL1           ( PWMB_BASE     + 0x7  )  //Value Register 1
#define  PWMB_PWMVAL2           ( PWMB_BASE     + 0x8  )  //Value Register 2
#define  PWMB_PWMVAL3           ( PWMB_BASE     + 0x9  )  //Value Register 3
#define  PWMB_PWMVAL4           ( PWMB_BASE     + 0xA  )  //Value Register 4
#define  PWMB_PWMVAL5           ( PWMB_BASE     + 0xB  )  //Value Register 5
#define  PWMB_PMDEADTM          ( PWMB_BASE     + 0xC  )  //Dead Time Register
#define  PWMB_PMDISMAP1         ( PWMB_BASE     + 0xD  )  //Disable Mapping Register 1
#define  PWMB_PMDISMAP2         ( PWMB_BASE     + 0xE  )  //Disable Mapping Register 2
#define  PWMB_PMCFG             ( PWMB_BASE     + 0xF  )  //Configure Register
#define  PWMB_PMCCR             ( PWMB_BASE     + 0x10 )  //Channel Control Register
#define  PWMB_PMPORT            ( PWMB_BASE     + 0x11 )  //Port Register
#define  PWMB_PMICCR            ( PWMB_BASE     + 0x12 )  //PWM Internal Correction Control Register
#define  DEC0_DECCR             ( DEC0_BASE     + 0x0  )  //Decoder Control Register
#define  DEC0_FIR               ( DEC0_BASE     + 0x1  )  //Filter Interval Register
#define  DEC0_WTR               ( DEC0_BASE     + 0x2  )  //Watchdog Time-out Register
#define  DEC0_POSD              ( DEC0_BASE     + 0x3  )  //Position Difference Counter Register
#define  DEC0_POSDH             ( DEC0_BASE     + 0x4  )  //Position Difference Counter Hold Register
#define  DEC0_REV               ( DEC0_BASE     + 0x5  )  //Revolution Counter Register
#define  DEC0_REVH              ( DEC0_BASE     + 0x6  )  //Revolution Hold Register
#define  DEC0_UPOS              ( DEC0_BASE     + 0x7  )  //Upper Position Counter Register
#define  DEC0_LPOS              ( DEC0_BASE     + 0x8  )  //Lower Position Counter Register
#define  DEC0_UPOSH             ( DEC0_BASE     + 0x9  )  //Upper Position Hold Register
#define  DEC0_LPOSH             ( DEC0_BASE     + 0xA  )  //Lower Position Hold Register
#define  DEC0_UIR               ( DEC0_BASE     + 0xB  )  //Upper Initialization Register
#define  DEC0_LIR               ( DEC0_BASE     + 0xC  )  //Lower Initialization Register
#define  DEC0_IMR               ( DEC0_BASE     + 0xD  )  //Input Monitor Register
#define  DEC1_DECCR             ( DEC1_BASE     + 0x0  )  //Decoder Control Register
#define  DEC1_FIR               ( DEC1_BASE     + 0x1  )  //Filter Interval Register
#define  DEC1_WTR               ( DEC1_BASE     + 0x2  )  //Watchdog Time-out Register
#define  DEC1_POSD              ( DEC1_BASE     + 0x3  )  //Position Difference Counter Register
#define  DEC1_POSDH             ( DEC1_BASE     + 0x4  )  //Position Difference Counter Hold Register
#define  DEC1_REV               ( DEC1_BASE     + 0x5  )  //Revolution Counter Register
#define  DEC1_REVH              ( DEC1_BASE     + 0x6  )  //Revolution Hold Register
#define  DEC1_UPOS              ( DEC1_BASE     + 0x7  )  //Upper Position Counter Register
#define  DEC1_LPOS              ( DEC1_BASE     + 0x8  )  //Lower Position Counter Register
#define  DEC1_UPOSH             ( DEC1_BASE     + 0x9  )  //Upper Position Hold Register
#define  DEC1_LPOSH             ( DEC1_BASE     + 0xA  )  //Lower Position Hold Register
#define  DEC1_UIR               ( DEC1_BASE     + 0xB  )  //Upper Initialization Register
#define  DEC1_LIR               ( DEC1_BASE     + 0xC  )  //Lower Initialization Register
#define  DEC1_IMR               ( DEC1_BASE     + 0xD  )  //Input Monitor Register
#define  IPR0                   ( ITCN_BASE     + 0x0  )  //Interrupt Priority Register 0
#define  IPR1                   ( ITCN_BASE     + 0x1  )  //Interrupt Priority Register 1
#define  IPR2                   ( ITCN_BASE     + 0x2  )  //Interrupt Priority Register 2
#define  IPR3                   ( ITCN_BASE     + 0x3  )  //Interrupt Priority Register 3
#define  IPR4                   ( ITCN_BASE     + 0x4  )  //Interrupt Priority Register 4
#define  IPR5                   ( ITCN_BASE     + 0x5  )  //Interrupt Priority Register 5
#define  IPR6                   ( ITCN_BASE     + 0x6  )  //Interrupt Priority Register 6
#define  IPR7                   ( ITCN_BASE     + 0x7  )  //Interrupt Priority Register 7
#define  IPR8                   ( ITCN_BASE     + 0x8  )  //Interrupt Priority Register 8
#define  IPR9                   ( ITCN_BASE     + 0x9  )  //Interrupt Priority Register 9
#define  VBA                    ( ITCN_BASE     + 0xA  )  //Vector Base Address Register
#define  FIM0                   ( ITCN_BASE     + 0xB  )  //Fast Interrupt Match Register 0
#define  FIVAL0                 ( ITCN_BASE     + 0xC  )  //Fast Interrupt Vector Address Low 0 Register
#define  FIVAH0                 ( ITCN_BASE     + 0xD  )  //Fast Interrupt Vector Address High 0 Register
#define  FIM1                   ( ITCN_BASE     + 0xE  )  //Fast Interrupt Match Register 1
#define  FIVAL1                 ( ITCN_BASE     + 0xF  )  //Fast Interrupt Vector Address Low 1 Register
#define  FIVAH1                 ( ITCN_BASE     + 0x10 )  //Fast Interrupt Vector Address High 1 Register
#define  IRQP0                  ( ITCN_BASE     + 0x11 )  //IRQ Pending Register 0
#define  IRQP1                  ( ITCN_BASE     + 0x12 )  //IRQ Pending Register 1
#define  IRQP2                  ( ITCN_BASE     + 0x13 )  //IRQ Pending Register 2
#define  IRQP3                  ( ITCN_BASE     + 0x14 )  //IRQ Pending Register 3
#define  IRQP4                  ( ITCN_BASE     + 0x15 )  //IRQ Pending Register 4
#define  IRQP5                  ( ITCN_BASE     + 0x16 )  //IRQ Pending Register 5
#define  ICTL                   ( ITCN_BASE     + 0x1D )  //Interrupt Control Register
#define  IPR10                  ( ITCN_BASE     + 0x1F )  //Interrupt Priority Register 10
#define  ADCA_CR1               ( ADCA_BASE     + 0x0  )  //Control Register 1
#define  ADCA_CR2               ( ADCA_BASE     + 0x1  )  //Control Register 2
#define  ADCA_ZCC               ( ADCA_BASE     + 0x2  )  //Zero Crossing Control Register
#define  ADCA_LST1              ( ADCA_BASE     + 0x3  )  //Channel List Register 1
#define  ADCA_LST2              ( ADCA_BASE     + 0x4  )  //Channel List Register 2
#define  ADCA_SDIS              ( ADCA_BASE     + 0x5  )  //Sample Disable Register
#define  ADCA_STAT              ( ADCA_BASE     + 0x6  )  //Status Register
#define  ADCA_LSTAT             ( ADCA_BASE     + 0x7  )  //Limit Status Register
#define  ADCA_ZCSTAT            ( ADCA_BASE     + 0x8  )  //Zero Crossing Status Register
#define  ADCA_RSLT0             ( ADCA_BASE     + 0x9  )  //Result Register 0
#define  ADCA_RSLT1             ( ADCA_BASE     + 0xA  )  //Result Register 1
#define  ADCA_RSLT2             ( ADCA_BASE     + 0xB  )  //Result Register 2
#define  ADCA_RSLT3             ( ADCA_BASE     + 0xC  )  //Result Register 3
#define  ADCA_RSLT4             ( ADCA_BASE     + 0xD  )  //Result Register 4
#define  ADCA_RSLT5             ( ADCA_BASE     + 0xE  )  //Result Register 5
#define  ADCA_RSLT6             ( ADCA_BASE     + 0xF  )  //Result Register 6
#define  ADCA_RSLT7             ( ADCA_BASE     + 0x10 )  //Result Register 7
#define  ADCA_LLMT0             ( ADCA_BASE     + 0x11 )  //Low Limit Register 0
#define  ADCA_LLMT1             ( ADCA_BASE     + 0x12 )  //Low Limit Register 1
#define  ADCA_LLMT2             ( ADCA_BASE     + 0x13 )  //Low Limit Register 2
#define  ADCA_LLMT3             ( ADCA_BASE     + 0x14 )  //Low Limit Register 3
#define  ADCA_LLMT4             ( ADCA_BASE     + 0x15 )  //Low Limit Register 4
#define  ADCA_LLMT5             ( ADCA_BASE     + 0x16 )  //Low Limit Register 5
#define  ADCA_LLMT6             ( ADCA_BASE     + 0x17 )  //Low Limit Register 6
#define  ADCA_LLMT7             ( ADCA_BASE     + 0x18 )  //Low Limit Register 7
#define  ADCA_HLMT0             ( ADCA_BASE     + 0x19 )  //High Limit Register 0
#define  ADCA_HLMT1             ( ADCA_BASE     + 0x1A )  //High Limit Register 1
#define  ADCA_HLMT2             ( ADCA_BASE     + 0x1B )  //High Limit Register 2
#define  ADCA_HLMT3             ( ADCA_BASE     + 0x1C )  //High Limit Register 3
#define  ADCA_HLMT4             ( ADCA_BASE     + 0x1D )  //High Limit Register 4
#define  ADCA_HLMT5             ( ADCA_BASE     + 0x1E )  //High Limit Register 5
#define  ADCA_HLMT6             ( ADCA_BASE     + 0x1F )  //High Limit Register 6
#define  ADCA_HLMT7             ( ADCA_BASE     + 0x20 )  //High Limit Register 7
#define  ADCA_OFS0              ( ADCA_BASE     + 0x21 )  //Offset Register 0
#define  ADCA_OFS1              ( ADCA_BASE     + 0x22 )  //Offset Register 1
#define  ADCA_OFS2              ( ADCA_BASE     + 0x23 )  //Offset Register 2
#define  ADCA_OFS3              ( ADCA_BASE     + 0x24 )  //Offset Register 3
#define  ADCA_OFS4              ( ADCA_BASE     + 0x25 )  //Offset Register 4
#define  ADCA_OFS5              ( ADCA_BASE     + 0x26 )  //Offset Register 5
#define  ADCA_OFS6              ( ADCA_BASE     + 0x27 )  //Offset Register 6
#define  ADCA_OFS7              ( ADCA_BASE     + 0x28 )  //Offset Register 7
#define  ADCA_POWER             ( ADCA_BASE     + 0x29 )  //Power Control Register
#define  ADCA_CAL               ( ADCA_BASE     + 0x2A )  //ADC Calibration Register
#define  ADCB_CR1               ( ADCB_BASE     + 0x0  )  //Control Register 1
#define  ADCB_CR2               ( ADCB_BASE     + 0x1  )  //Control Register 2
#define  ADCB_ZCC               ( ADCB_BASE     + 0x2  )  //Zero Crossing Control Register
#define  ADCB_LST1              ( ADCB_BASE     + 0x3  )  //Channel List Register 1
#define  ADCB_LST2              ( ADCB_BASE     + 0x4  )  //Channel List Register 2
#define  ADCB_SDIS              ( ADCB_BASE     + 0x5  )  //Sample Disable Register
#define  ADCB_STAT              ( ADCB_BASE     + 0x6  )  //Status Register
#define  ADCB_LSTAT             ( ADCB_BASE     + 0x7  )  //Limit Status Register
#define  ADCB_ZCSTAT            ( ADCB_BASE     + 0x8  )  //Zero Crossing Status Register
#define  ADCB_RSLT0             ( ADCB_BASE     + 0x9  )  //Result Register 0
#define  ADCB_RSLT1             ( ADCB_BASE     + 0xA  )  //Result Register 1
#define  ADCB_RSLT2             ( ADCB_BASE     + 0xB  )  //Result Register 2
#define  ADCB_RSLT3             ( ADCB_BASE     + 0xC  )  //Result Register 3
#define  ADCB_RSLT4             ( ADCB_BASE     + 0xD  )  //Result Register 4
#define  ADCB_RSLT5             ( ADCB_BASE     + 0xE  )  //Result Register 5
#define  ADCB_RSLT6             ( ADCB_BASE     + 0xF  )  //Result Register 6
#define  ADCB_RSLT7             ( ADCB_BASE     + 0x10 )  //Result Register 7
#define  ADCB_LLMT0             ( ADCB_BASE     + 0x11 )  //Low Limit Register 0
#define  ADCB_LLMT1             ( ADCB_BASE     + 0x12 )  //Low Limit Register 1
#define  ADCB_LLMT2             ( ADCB_BASE     + 0x13 )  //Low Limit Register 2
#define  ADCB_LLMT3             ( ADCB_BASE     + 0x14 )  //Low Limit Register 3
#define  ADCB_LLMT4             ( ADCB_BASE     + 0x15 )  //Low Limit Register 4
#define  ADCB_LLMT5             ( ADCB_BASE     + 0x16 )  //Low Limit Register 5
#define  ADCB_LLMT6             ( ADCB_BASE     + 0x17 )  //Low Limit Register 6
#define  ADCB_LLMT7             ( ADCB_BASE     + 0x18 )  //Low Limit Register 7
#define  ADCB_HLMT0             ( ADCB_BASE     + 0x19 )  //High Limit Register 0
#define  ADCB_HLMT1             ( ADCB_BASE     + 0x1A )  //High Limit Register 1
#define  ADCB_HLMT2             ( ADCB_BASE     + 0x1B )  //High Limit Register 2
#define  ADCB_HLMT3             ( ADCB_BASE     + 0x1C )  //High Limit Register 3
#define  ADCB_HLMT4             ( ADCB_BASE     + 0x1D )  //High Limit Register 4
#define  ADCB_HLMT5             ( ADCB_BASE     + 0x1E )  //High Limit Register 5
#define  ADCB_HLMT6             ( ADCB_BASE     + 0x1F )  //High Limit Register 6
#define  ADCB_HLMT7             ( ADCB_BASE     + 0x20 )  //High Limit Register 7
#define  ADCB_OFS0              ( ADCB_BASE     + 0x21 )  //Offset Register 0
#define  ADCB_OFS1              ( ADCB_BASE     + 0x22 )  //Offset Register 1
#define  ADCB_OFS2              ( ADCB_BASE     + 0x23 )  //Offset Register 2
#define  ADCB_OFS3              ( ADCB_BASE     + 0x24 )  //Offset Register 3
#define  ADCB_OFS4              ( ADCB_BASE     + 0x25 )  //Offset Register 4
#define  ADCB_OFS5              ( ADCB_BASE     + 0x26 )  //Offset Register 5
#define  ADCB_OFS6              ( ADCB_BASE     + 0x27 )  //Offset Register 6
#define  ADCB_OFS7              ( ADCB_BASE     + 0x28 )  //Offset Register 7
#define  ADCB_POWER             ( ADCB_BASE     + 0x29 )  //Power Control Register
#define  ADCB_CAL               ( ADCB_BASE     + 0x2A )  //ADC Calibration Register
#define  TSENSOR_CNTL           ( TSENSOR_BASE  + 0x0  )  //Control Register
#define  SCI0_SCIBR             ( SCI0_BASE     + 0x0  )  //Baud Rate Register
#define  SCI0_SCICR             ( SCI0_BASE     + 0x1  )  //Control Register
#define  SCI0_SCISR             ( SCI0_BASE     + 0x3  )  //Status Register
#define  SCI0_SCIDR             ( SCI0_BASE     + 0x4  )  //Data Register
#define  SCI1_SCIBR             ( SCI1_BASE     + 0x0  )  //Baud Rate Register
#define  SCI1_SCICR             ( SCI1_BASE     + 0x1  )  //Control Register
#define  SCI1_SCISR             ( SCI1_BASE     + 0x3  )  //Status Register
#define  SCI1_SCIDR             ( SCI1_BASE     + 0x4  )  //Data Register
#define  SPI0_SPSCR             ( SPI0_BASE     + 0x0  )  //Status and Control Register
#define  SPI0_SPDSR             ( SPI0_BASE     + 0x1  )  //Data Size Register
#define  SPI0_SPDRR             ( SPI0_BASE     + 0x2  )  //Data Receive Register
#define  SPI0_SPDTR             ( SPI0_BASE     + 0x3  )  //Data Transmitter Register
#define  SPI1_SPSCR             ( SPI1_BASE     + 0x0  )  //Status and Control Register
#define  SPI1_SPDSR             ( SPI1_BASE     + 0x1  )  //Data Size Register
#define  SPI1_SPDRR             ( SPI1_BASE     + 0x2  )  //Data Receive Register
#define  SPI1_SPDTR             ( SPI1_BASE     + 0x3  )  //Data Transmitter Register
#define  COPCTL                 ( COP_BASE      + 0x0  )  //Control Register
#define  COPTO                  ( COP_BASE      + 0x1  )  //Time Out Register
#define  COPCTR                 ( COP_BASE      + 0x2  )  //Counter Register
#define  PLLCR                  ( CLKGEN_BASE   + 0x0  )  //Control Register
#define  PLLDB                  ( CLKGEN_BASE   + 0x1  )  //Divide-By Register
#define  PLLSR                  ( CLKGEN_BASE   + 0x2  )  //Status Register
#define  SHUTDOWN               ( CLKGEN_BASE   + 0x4  )  //Shutdown Register
#define  OSCTL                  ( CLKGEN_BASE   + 0x5  )  //Oscillator Control Register
#define  GPIOA_PUR              ( GPIOA_BASE    + 0x0  )  //Pull-up Enable Register
#define  GPIOA_DR               ( GPIOA_BASE    + 0x1  )  //Data Register
#define  GPIOA_DDR              ( GPIOA_BASE    + 0x2  )  //Data Direction Register
#define  GPIOA_PER              ( GPIOA_BASE    + 0x3  )  //Peripheral Enable Register
#define  GPIOA_IAR              ( GPIOA_BASE    + 0x4  )  //Interrupt Assert Register
#define  GPIOA_IENR             ( GPIOA_BASE    + 0x5  )  //Interrupt Enable Register
#define  GPIOA_IPOLR            ( GPIOA_BASE    + 0x6  )  //Interrupt Polarity Register
#define  GPIOA_IPR              ( GPIOA_BASE    + 0x7  )  //Interrupt Pending Register
#define  GPIOA_IESR             ( GPIOA_BASE    + 0x8  )  //Interrupt Edge-Sensitive Register
#define  GPIOA_PPMODE           ( GPIOA_BASE    + 0x9  )  //Push-Pull Mode Register
#define  GPIOA_RAWDATA          ( GPIOA_BASE    + 0xA  )  //Raw Data Input Register
#define  GPIOB_PUR              ( GPIOB_BASE    + 0x0  )  //Pull-up Enable Register
#define  GPIOB_DR               ( GPIOB_BASE    + 0x1  )  //Data Register
#define  GPIOB_DDR              ( GPIOB_BASE    + 0x2  )  //Data Direction Register
#define  GPIOB_PER              ( GPIOB_BASE    + 0x3  )  //Peripheral Enable Register
#define  GPIOB_IAR              ( GPIOB_BASE    + 0x4  )  //Interrupt Assert Register
#define  GPIOB_IENR             ( GPIOB_BASE    + 0x5  )  //Interrupt Enable Register
#define  GPIOB_IPOLR            ( GPIOB_BASE    + 0x6  )  //Interrupt Polarity Register
#define  GPIOB_IPR              ( GPIOB_BASE    + 0x7  )  //Interrupt Pending Register
#define  GPIOB_IESR             ( GPIOB_BASE    + 0x8  )  //Interrupt Edge-Sensitive Register
#define  GPIOB_PPMODE           ( GPIOB_BASE    + 0x9  )  //Push-Pull Mode Register
#define  GPIOB_RAWDATA          ( GPIOB_BASE    + 0xA  )  //Raw Data Input Register
#define  GPIOC_PUR              ( GPIOC_BASE    + 0x0  )  //Pull-up Enable Register
#define  GPIOC_DR               ( GPIOC_BASE    + 0x1  )  //Data Register
#define  GPIOC_DDR              ( GPIOC_BASE    + 0x2  )  //Data Direction Register
#define  GPIOC_PER              ( GPIOC_BASE    + 0x3  )  //Peripheral Enable Register
#define  GPIOC_IAR              ( GPIOC_BASE    + 0x4  )  //Interrupt Assert Register
#define  GPIOC_IENR             ( GPIOC_BASE    + 0x5  )  //Interrupt Enable Register
#define  GPIOC_IPOLR            ( GPIOC_BASE    + 0x6  )  //Interrupt Polarity Register
#define  GPIOC_IPR              ( GPIOC_BASE    + 0x7  )  //Interrupt Pending Register
#define  GPIOC_IESR             ( GPIOC_BASE    + 0x8  )  //Interrupt Edge-Sensitive Register
#define  GPIOC_PPMODE           ( GPIOC_BASE    + 0x9  )  //Push-Pull Mode Register
#define  GPIOC_RAWDATA          ( GPIOC_BASE    + 0xA  )  //Raw Data Input Register
#define  GPIOD_PUR              ( GPIOD_BASE    + 0x0  )  //Pull-up Enable Register
#define  GPIOD_DR               ( GPIOD_BASE    + 0x1  )  //Data Register
#define  GPIOD_DDR              ( GPIOD_BASE    + 0x2  )  //Data Direction Register
#define  GPIOD_PER              ( GPIOD_BASE    + 0x3  )  //Peripheral Enable Register
#define  GPIOD_IAR              ( GPIOD_BASE    + 0x4  )  //Interrupt Assert Register
#define  GPIOD_IENR             ( GPIOD_BASE    + 0x5  )  //Interrupt Enable Register
#define  GPIOD_IPOLR            ( GPIOD_BASE    + 0x6  )  //Interrupt Polarity Register
#define  GPIOD_IPR              ( GPIOD_BASE    + 0x7  )  //Interrupt Pending Register
#define  GPIOD_IESR             ( GPIOD_BASE    + 0x8  )  //Interrupt Edge-Sensitive Register
#define  GPIOD_PPMODE           ( GPIOD_BASE    + 0x9  )  //Push-Pull Mode Register
#define  GPIOD_RAWDATA          ( GPIOD_BASE    + 0xA  )  //Raw Data Input Register
#define  GPIOE_PUR              ( GPIOE_BASE    + 0x0  )  //Pull-up Enable Register
#define  GPIOE_DR               ( GPIOE_BASE    + 0x1  )  //Data Register
#define  GPIOE_DDR              ( GPIOE_BASE    + 0x2  )  //Data Direction Register
#define  GPIOE_PER              ( GPIOE_BASE    + 0x3  )  //Peripheral Enable Register
#define  GPIOE_IAR              ( GPIOE_BASE    + 0x4  )  //Interrupt Assert Register
#define  GPIOE_IENR             ( GPIOE_BASE    + 0x5  )  //Interrupt Enable Register
#define  GPIOE_IPOLR            ( GPIOE_BASE    + 0x6  )  //Interrupt Polarity Register
#define  GPIOE_IPR              ( GPIOE_BASE    + 0x7  )  //Interrupt Pending Register
#define  GPIOE_IESR             ( GPIOE_BASE    + 0x8  )  //Interrupt Edge-Sensitive Register
#define  GPIOE_PPMODE           ( GPIOE_BASE    + 0x9  )  //Push-Pull Mode Register
#define  GPIOE_RAWDATA          ( GPIOE_BASE    + 0xA  )  //Raw Data Input Register
#define  GPIOF_PUR              ( GPIOF_BASE    + 0x0  )  //Pull-up Enable Register
#define  GPIOF_DR               ( GPIOF_BASE    + 0x1  )  //Data Register
#define  GPIOF_DDR              ( GPIOF_BASE    + 0x2  )  //Data Direction Register
#define  GPIOF_PER              ( GPIOF_BASE    + 0x3  )  //Peripheral Enable Register
#define  GPIOF_IAR              ( GPIOF_BASE    + 0x4  )  //Interrupt Assert Register
#define  GPIOF_IENR             ( GPIOF_BASE    + 0x5  )  //Interrupt Enable Register
#define  GPIOF_IPOLR            ( GPIOF_BASE    + 0x6  )  //Interrupt Polarity Register
#define  GPIOF_IPR              ( GPIOF_BASE    + 0x7  )  //Interrupt Pending Register
#define  GPIOF_IESR             ( GPIOF_BASE    + 0x8  )  //Interrupt Edge-Sensitive Register
#define  GPIOF_PPMODE           ( GPIOF_BASE    + 0x9  )  //Push-Pull Mode Register
#define  GPIOF_RAWDATA          ( GPIOF_BASE    + 0xA  )  //Raw Data Input Register
#define  SIM_CONTROL            ( SIM_BASE      + 0x0  )  //Control Register
#define  SIM_RSTSTS             ( SIM_BASE      + 0x1  )  //Reset Status Register
#define  SIM_SCR0               ( SIM_BASE      + 0x2  )  //Software Control Register 0
#define  SIM_SCR1               ( SIM_BASE      + 0x3  )  //Software Control Register 1
#define  SIM_SCR2               ( SIM_BASE      + 0x4  )  //Software Control Register 2
#define  SIM_SCR3               ( SIM_BASE      + 0x5  )  //Software Control Register 3
#define  SIM_MSH_ID             ( SIM_BASE      + 0x6  )  //Most Significant Half JTAG ID
#define  SIM_LSH_ID             ( SIM_BASE      + 0x7  )  //Least Significant Half JTAG ID
#define  SIM_PUDR               ( SIM_BASE      + 0x8  )  //Pull-up Disable Register
#define  SIM_CLKOSR             ( SIM_BASE      + 0xA  )  //Clock Out Select Register
#define  SIM_GPS                ( SIM_BASE      + 0xB  )  //Quad Decoder 1 / Timer B / SPI 1 Select Register
#define  SIM_PCE                ( SIM_BASE      + 0xC  )  //Peripheral Clock Enable Register
#define  SIM_ISALH              ( SIM_BASE      + 0xD  )  //I/O Short Address Location High Register
#define  SIM_ISALL              ( SIM_BASE      + 0xE  )  //I/O Short Address Location Low Register
#define  SIM_PCE2               ( SIM_BASE      + 0xF  )  //Peripheral Clock Enable Register 2
#define  LVI_CONTROL            ( LVI_BASE      + 0x0  )  //Control Register
#define  LVI_STATUS             ( LVI_BASE      + 0x1  )  //Status Register
#define  FMCLKD                 ( FM_BASE       + 0x0  )  //Clock Divider Register
#define  FMMCR                  ( FM_BASE       + 0x1  )  //Module Control Register
#define  FMSECH                 ( FM_BASE       + 0x3  )  //Security High Half Register
#define  FMSECL                 ( FM_BASE       + 0x4  )  //Security Low Half Register
#define  FMPROT                 ( FM_BASE       + 0x10 )  //Protection Register (Banked)
#define  FMPROTB                ( FM_BASE       + 0x11 )  //Protection Boot Register (Banked)
#define  FMUSTAT                ( FM_BASE       + 0x13 )  //User Status Register (Banked)
#define  FMCMD                  ( FM_BASE       + 0x14 )  //Command Register (Banked)
#define  FMOPT0                 ( FM_BASE       + 0x1A )  //16-Bit Information Option Register 0
#define  FMOPT1                 ( FM_BASE       + 0x1B )  //16-Bit Information Option Register 1
#define  FMOPT2                 ( FM_BASE       + 0x1C )  //16-Bit Information Option Register 2
#define  FCMCR                  ( FC_BASE       + 0x0  )  //Module Configuration Register
#define  FCCTL0                 ( FC_BASE       + 0x3  )  //Control Register 0 Register
#define  FCCTL1                 ( FC_BASE       + 0x4  )  //Control Register 1 Register
#define  FCTMR                  ( FC_BASE       + 0x5  )  //Free-Running Timer Register
#define  FCMAXMB                ( FC_BASE       + 0x6  )  //Maximum Message Buffer Configuration Register
#define  FCRXGMASK_H            ( FC_BASE       + 0x8  )  //Receive Global Mask High Register
#define  FCRXGMASK_L            ( FC_BASE       + 0x9  )  //Receive Global Mask Low Register
#define  FCRX14MASK_H           ( FC_BASE       + 0xA  )  //Receive Buffer 14 Mask High Register
#define  FCRX14MASK_L           ( FC_BASE       + 0xB  )  //Receive Buffer 14 Mask Low Register
#define  FCRX15MASK_H           ( FC_BASE       + 0xC  )  //Receive Buffer 15 Mask High Register
#define  FCRX15MASK_L           ( FC_BASE       + 0xD  )  //Receive Buffer 15 Mask Low Register
#define  FCSTATUS               ( FC_BASE       + 0x10 )  //Error and Status Register
#define  FCIMASK1               ( FC_BASE       + 0x11 )  //Interrupt Masks 1 Register
#define  FCIFLAG1               ( FC_BASE       + 0x12 )  //Interrupt Flags 1 Register
#define  FCR__T_ERROR_CNTRS     ( FC_BASE       + 0x13 )  //Receive and Transmit Error Counters Register
#define  FCMB0_CONTROL          ( FC_BASE       + 0x40 )  //Message Buffer 0 Control / Status Register
#define  FCMB0_ID_HIGH          ( FC_BASE       + 0x41 )  //Message Buffer 0 ID High Register
#define  FCMB0_ID_LOW           ( FC_BASE       + 0x42 )  //Message Buffer 0 ID Low Register
#define  FCMB0_DATA             ( FC_BASE       + 0x43 )  //Message Buffer 0 Data Register
#define  FCMSB1_CONTROL         ( FC_BASE       + 0x48 )  //Message Buffer 1 Control / Status Register
#define  FCMSB1_ID_HIGH         ( FC_BASE       + 0x49 )  //Message Buffer 1 ID High Register
#define  FCMSB1_ID_LOW          ( FC_BASE       + 0x4A )  //Message Buffer 1 ID Low Register
#define  FCMB1_DATA             ( FC_BASE       + 0x4B )  //Message Buffer 1 Data Register
#define  FCMB2_CONTROL          ( FC_BASE       + 0x50 )  //Message Buffer 2 Control / Status Register
#define  FCMB2_ID_HIGH          ( FC_BASE       + 0x51 )  //Message Buffer 2 ID High Register
#define  FCMB2_ID_LOW           ( FC_BASE       + 0x52 )  //Message Buffer 2 ID Low Register
#define  FCMB2_DATA             ( FC_BASE       + 0x53 )  //Message Buffer 2 Data Register
#define  FCMB3_CONTROL          ( FC_BASE       + 0x58 )  //Message Buffer 3 Control / Status Register
#define  FCMB3_ID_HIGH          ( FC_BASE       + 0x59 )  //Message Buffer 3 ID High Register
#define  FCMB3_ID_LOW           ( FC_BASE       + 0x5A )  //Message Buffer 3 ID Low Register
#define  FCMB3_DATA             ( FC_BASE       + 0x5B )  //Message Buffer 3 Data Register
#define  FCMB4_CONTROL          ( FC_BASE       + 0x60 )  //Message Buffer 4 Control / Status Register
#define  FCMB4_ID_HIGH          ( FC_BASE       + 0x61 )  //Message Buffer 4 ID High Register
#define  FCMB4_ID_LOW           ( FC_BASE       + 0x62 )  //Message Buffer 4 ID Low Register
#define  FCMB4_DATA             ( FC_BASE       + 0x63 )  //Message Buffer 4 Data Register
#define  FCMB5_CONTROL          ( FC_BASE       + 0x68 )  //Message Buffer 5 Control / Status Register
#define  FCMB5_ID_HIGH          ( FC_BASE       + 0x69 )  //Message Buffer 5 ID High Register
#define  FCMB5_ID_LOW           ( FC_BASE       + 0x6A )  //Message Buffer 5 ID Low Register
#define  FCMB5_DATA             ( FC_BASE       + 0x6B )  //Message Buffer 5 Data Register
#define  FCMB6_CONTROL          ( FC_BASE       + 0x70 )  //Message Buffer 6 Control / Status Register
#define  FCMB6_ID_HIGH          ( FC_BASE       + 0x71 )  //Message Buffer 6 ID High Register
#define  FCMB6_ID_LOW           ( FC_BASE       + 0x72 )  //Message Buffer 6 ID Low Register
#define  FCMB6_DATA             ( FC_BASE       + 0x73 )  //Message Buffer 6 Data Register
#define  FCMB7_CONTROL          ( FC_BASE       + 0x78 )  //Message Buffer 7 Control / Status Register
#define  FCMB7_ID_HIGH          ( FC_BASE       + 0x79 )  //Message Buffer 7 ID High Register
#define  FCMB7_ID_LOW           ( FC_BASE       + 0x7A )  //Message Buffer 7 ID Low Register
#define  FCMB7_DATA             ( FC_BASE       + 0x7B )  //Message Buffer 7 Data Register
#define  FCMB8_CONTROL          ( FC_BASE       + 0x80 )  //Message Buffer 8 Control / Status Register
#define  FCMB8_ID_HIGH          ( FC_BASE       + 0x81 )  //Message Buffer 8 ID High Register
#define  FCMB8_ID_LOW           ( FC_BASE       + 0x82 )  //Message Buffer 8 ID Low Register
#define  FCMB8_DATA             ( FC_BASE       + 0x83 )  //Message Buffer 8 Data Register
#define  FCMB9_CONTROL          ( FC_BASE       + 0x88 )  //Message Buffer 9 Control / Status Register
#define  FCMB9_ID_HIGH          ( FC_BASE       + 0x89 )  //Message Buffer 9 ID High Register
#define  FCMB9_ID_LOW           ( FC_BASE       + 0x8A )  //Message Buffer 9 ID Low Register
#define  FCMB9_DATA             ( FC_BASE       + 0x8B )  //Message Buffer 9 Data Register
#define  FCMB10_CONTROL         ( FC_BASE       + 0x90 )  //Message Buffer 10 Control / Status Register
#define  FCMB10_ID_HIGH         ( FC_BASE       + 0x91 )  //Message Buffer 10 ID High Register
#define  FCMB10_ID_LOW          ( FC_BASE       + 0x92 )  //Message Buffer 10 ID Low Register
#define  FCMB10_DATA            ( FC_BASE       + 0x93 )  //Message Buffer 10 Data Register
#define  FCMB11_CONTROL         ( FC_BASE       + 0x98 )  //Message Buffer 11 Control / Status Register
#define  FCMB11_ID_HIGH         ( FC_BASE       + 0x99 )  //Message Buffer 11 ID High Register
#define  FCMB11_ID_LOW          ( FC_BASE       + 0x9A )  //Message Buffer 11 ID Low Register
#define  FCMB11_DATA            ( FC_BASE       + 0x9B )  //Message Buffer 11 Data Register
#define  FCMB12_CONTROL         ( FC_BASE       + 0xA0 )  //Message Buffer 12 Control / Status Register
#define  FCMB12_ID_HIGH         ( FC_BASE       + 0xA1 )  //Message Buffer 12 ID High Register
#define  FCMB12_ID_LOW          ( FC_BASE       + 0xA2 )  //Message Buffer 12 ID Low Register
#define  FCMB12_DATA            ( FC_BASE       + 0xA3 )  //Message Buffer 12 Data Register
#define  FCMB13_CONTROL         ( FC_BASE       + 0xA8 )  //Message Buffer 13 Control / Status Register
#define  FCMB13_ID_HIGH         ( FC_BASE       + 0xA9 )  //Message Buffer 13 ID High Register
#define  FCMB13_ID_LOW          ( FC_BASE       + 0xAA )  //Message Buffer 13 ID Low Register
#define  FCMB13_DATA            ( FC_BASE       + 0xAB )  //Message Buffer 13 Data Register
#define  FCMB14_CONTROL         ( FC_BASE       + 0xB0 )  //Message Buffer 14 Control / Status Register
#define  FCMB14_ID_HIGH         ( FC_BASE       + 0xB1 )  //Message Buffer 14 ID High Register
#define  FCMB14_ID_LOW          ( FC_BASE       + 0xB2 )  //Message Buffer 14 ID Low Register
#define  FCMB14_DATA            ( FC_BASE       + 0xB3 )  //Message Buffer 14 Data Register
#define  FCMB15_CONTROL         ( FC_BASE       + 0xB8 )  //Message Buffer 15 Control / Status Register
#define  FCMB15_ID_HIGH         ( FC_BASE       + 0xB9 )  //Message Buffer 15 ID High Register
#define  FCMB15_ID_LOW          ( FC_BASE       + 0xBA )  //Message Buffer 15 ID Low Register
#define  FCMB15_DATA            ( FC_BASE       + 0xBB )  //Message Buffer 15 Data Register
#define  FC2MCR                 ( FC2_BASE      + 0x0  )  //Module Configuration Register
#define  FC2CTL0                ( FC2_BASE      + 0x3  )  //Control Register 0 Register
#define  FC2CTL1                ( FC2_BASE      + 0x4  )  //Control Register 1 Register
#define  FC2TMR                 ( FC2_BASE      + 0x5  )  //Free-Running Timer Register
#define  FC2MAXMB               ( FC2_BASE      + 0x6  )  //Maximum Message Buffer Configuration Register
#define  FC2IMASK2              ( FC2_BASE      + 0x7  )  //Interrupt Masks 2 Register
#define  FC2RXGMASK_H           ( FC2_BASE      + 0x8  )  //Receive Global Mask High Register
#define  FC2RXGMASK_L           ( FC2_BASE      + 0x9  )  //Receive Global Mask Low Register
#define  FC2RX14MASK_H          ( FC2_BASE      + 0xA  )  //Receive Buffer 14 Mask High Register
#define  FC2RX14MASK_L          ( FC2_BASE      + 0xB  )  //Receive Buffer 14 Mask Low Register
#define  FC2RX15MASK_H          ( FC2_BASE      + 0xC  )  //Receive Buffer 15 Mask High Register
#define  FC2RX15MASK_L          ( FC2_BASE      + 0xD  )  //Receive Buffer 15 Mask Low Register
#define  FC2STATUS              ( FC2_BASE      + 0x10 )  //Error and Status Register
#define  FC2IMASK1              ( FC2_BASE      + 0x11 )  //Interrupt Masks 1 Register
#define  FC2IFLAG1              ( FC2_BASE      + 0x12 )  //Interrupt Flags 1 Register
#define  FC2R__T_ERROR_CNTRS    ( FC2_BASE      + 0x13 )  //Receive and Transmit Error Counters Register
#define  FC2IFLAG2              ( FC2_BASE      + 0x1B )  //Interrupt Flags 2 Register
#define  FC2MB0_CONTROL         ( FC2_BASE      + 0x40 )  //Message Buffer 0 Control / Status Register
#define  FC2MB0_ID_HIGH         ( FC2_BASE      + 0x41 )  //Message Buffer 0 ID High Register
#define  FC2MB0_ID_LOW          ( FC2_BASE      + 0x42 )  //Message Buffer 0 ID Low Register
#define  FC2MB0_DATA            ( FC2_BASE      + 0x43 )  //Message Buffer 0 Data Register
#define  FC2MSB1_CONTROL        ( FC2_BASE      + 0x48 )  //Message Buffer 1 Control / Status Register
#define  FC2MSB1_ID_HIGH        ( FC2_BASE      + 0x49 )  //Message Buffer 1 ID High Register
#define  FC2MSB1_ID_LOW         ( FC2_BASE      + 0x4A )  //Message Buffer 1 ID Low Register
#define  FC2MB1_DATA            ( FC2_BASE      + 0x4B )  //Message Buffer 1 Data Register
#define  FC2MB2_CONTROL         ( FC2_BASE      + 0x50 )  //Message Buffer 2 Control / Status Register
#define  FC2MB2_ID_HIGH         ( FC2_BASE      + 0x51 )  //Message Buffer 2 ID High Register
#define  FC2MB2_ID_LOW          ( FC2_BASE      + 0x52 )  //Message Buffer 2 ID Low Register
#define  FC2MB2_DATA            ( FC2_BASE      + 0x53 )  //Message Buffer 2 Data Register
#define  FC2MB3_CONTROL         ( FC2_BASE      + 0x58 )  //Message Buffer 3 Control / Status Register
#define  FC2MB3_ID_HIGH         ( FC2_BASE      + 0x59 )  //Message Buffer 3 ID High Register
#define  FC2MB3_ID_LOW          ( FC2_BASE      + 0x5A )  //Message Buffer 3 ID Low Register
#define  FC2MB3_DATA            ( FC2_BASE      + 0x5B )  //Message Buffer 3 Data Register
#define  FC2MB4_CONTROL         ( FC2_BASE      + 0x60 )  //Message Buffer 4 Control / Status Register
#define  FC2MB4_ID_HIGH         ( FC2_BASE      + 0x61 )  //Message Buffer 4 ID High Register
#define  FC2MB4_ID_LOW          ( FC2_BASE      + 0x62 )  //Message Buffer 4 ID Low Register
#define  FC2MB4_DATA            ( FC2_BASE      + 0x63 )  //Message Buffer 4 Data Register
#define  FC2MB5_CONTROL         ( FC2_BASE      + 0x68 )  //Message Buffer 5 Control / Status Register
#define  FC2MB5_ID_HIGH         ( FC2_BASE      + 0x69 )  //Message Buffer 5 ID High Register
#define  FC2MB5_ID_LOW          ( FC2_BASE      + 0x6A )  //Message Buffer 5 ID Low Register
#define  FC2MB5_DATA            ( FC2_BASE      + 0x6B )  //Message Buffer 5 Data Register
#define  FC2MB6_CONTROL         ( FC2_BASE      + 0x70 )  //Message Buffer 6 Control / Status Register
#define  FC2MB6_ID_HIGH         ( FC2_BASE      + 0x71 )  //Message Buffer 6 ID High Register
#define  FC2MB6_ID_LOW          ( FC2_BASE      + 0x72 )  //Message Buffer 6 ID Low Register
#define  FC2MB6_DATA            ( FC2_BASE      + 0x73 )  //Message Buffer 6 Data Register
#define  FC2MB7_CONTROL         ( FC2_BASE      + 0x78 )  //Message Buffer 7 Control / Status Register
#define  FC2MB7_ID_HIGH         ( FC2_BASE      + 0x79 )  //Message Buffer 7 ID High Register
#define  FC2MB7_ID_LOW          ( FC2_BASE      + 0x7A )  //Message Buffer 7 ID Low Register
#define  FC2MB7_DATA            ( FC2_BASE      + 0x7B )  //Message Buffer 7 Data Register
#define  FC2MB8_CONTROL         ( FC2_BASE      + 0x80 )  //Message Buffer 8 Contro l /Status Register
#define  FC2MB8_ID_HIGH         ( FC2_BASE      + 0x81 )  //Message Buffer 8 ID High Register
#define  FC2MB8_ID_LOW          ( FC2_BASE      + 0x82 )  //Message Buffer 8 ID Low Register
#define  FC2MB8_DATA            ( FC2_BASE      + 0x83 )  //Message Buffer 8 Data Register
#define  FC2MB9_CONTROL         ( FC2_BASE      + 0x88 )  //Message Buffer 9 Control / Status Register
#define  FC2MB9_ID_HIGH         ( FC2_BASE      + 0x89 )  //Message Buffer 9 ID High Register
#define  FC2MB9_ID_LOW          ( FC2_BASE      + 0x8A )  //Message Buffer 9 ID Low Register
#define  FC2MB9_DATA            ( FC2_BASE      + 0x8B )  //Message Buffer 9 Data Register
#define  FC2MB10_CONTROL        ( FC2_BASE      + 0x90 )  //Message Buffer 10 Control / Status Register
#define  FC2MB10_ID_HIGH        ( FC2_BASE      + 0x91 )  //Message Buffer 10 ID High Register
#define  FC2MB10_ID_LOW         ( FC2_BASE      + 0x92 )  //Message Buffer 10 ID Low Register
#define  FC2MB10_DATA           ( FC2_BASE      + 0x93 )  //Message Buffer 10 Data Register
#define  FC2MB11_CONTROL        ( FC2_BASE      + 0x98 )  //Message Buffer 11 Control / Status Register
#define  FC2MB11_ID_HIGH        ( FC2_BASE      + 0x99 )  //Message Buffer 11 ID High Register
#define  FC2MB11_ID_LOW         ( FC2_BASE      + 0x9A )  //Message Buffer 11 ID Low Register
#define  FC2MB11_DATA           ( FC2_BASE      + 0x9B )  //Message Buffer 11 Data Register
#define  FC2MB12_CONTROL        ( FC2_BASE      + 0xA0 )  //Message Buffer 12 Control / Status Register
#define  FC2MB12_ID_HIGH        ( FC2_BASE      + 0xA1 )  //Message Buffer 12 ID High Register
#define  FC2MB12_ID_LOW         ( FC2_BASE      + 0xA2 )  //Message Buffer 12 ID Low Register
#define  FC2MB12_DATA           ( FC2_BASE      + 0xA3 )  //Message Buffer 12 Data Register
#define  FC2MB13_CONTROL        ( FC2_BASE      + 0xA8 )  //Message Buffer 13 Control / Status Register
#define  FC2MB13_ID_HIGH        ( FC2_BASE      + 0xA9 )  //Message Buffer 13 ID High Register
#define  FC2MB13_ID_LOW         ( FC2_BASE      + 0xAA )  //Message Buffer 13 ID Low Register
#define  FC2MB13_DATA           ( FC2_BASE      + 0xAB )  //Message Buffer 13 Data Register
#define  FC2MB14_CONTROL        ( FC2_BASE      + 0xB0 )  //Message Buffer 14 Control / Status Register
#define  FC2MB14_ID_HIGH        ( FC2_BASE      + 0xB1 )  //Message Buffer 14 ID High Register
#define  FC2MB14_ID_LOW         ( FC2_BASE      + 0xB2 )  //Message Buffer 14 ID Low Register
#define  FC2MB14_DATA           ( FC2_BASE      + 0xB3 )  //Message Buffer 14 Data Register
#define  FC2MB15_CONTROL        ( FC2_BASE      + 0xB8 )  //Message Buffer 15 Control / Status Register
#define  FC2MB15_ID_HIGH        ( FC2_BASE      + 0xB9 )  //Message Buffer 15 ID High Register
#define  FC2MB15_ID_LOW         ( FC2_BASE      + 0xBA )  //Message Buffer 15 ID Low Register
#define  FC2MB15_DATA           ( FC2_BASE      + 0xBB )  //Message Buffer 15 Data Register

#define Non_Data_Sheet_Format_Version
#ifdef Non_Data_Sheet_Format_Version


// Serial Communications Interface 0  (SCI0) 

//#define SCI0_BASE 0x00F280

#define SCI0_DR		(SCI0_BASE + 3)
#define SCI0_SR		(SCI0_BASE + 2)
#define SCI0_CR		(SCI0_BASE + 1)
#define SCI0_BR		(SCI0_BASE + 0)



// Serial Communications Interface 1  (SCI1) 

//#define SCI1_BASE 0x00F290

#define SCI1_DR		(SCI1_BASE + 3)
#define SCI1_SR		(SCI1_BASE + 2)
#define SCI1_CR		(SCI1_BASE + 1)
#define SCI1_BR		(SCI1_BASE + 0)



// Serial Peripheral Interface 0  (SPI0) 

//#define SPI0_BASE 0x00F2A0

#define SPI0_DTR		(SPI0_BASE + 3)
#define SPI0_DRR		(SPI0_BASE + 2)
#define SPI0_DSR		(SPI0_BASE + 1)
#define SPI0_SCR		(SPI0_BASE + 0)



// Serial Peripheral Interface 1  (SPI1) 

//#define SPI1_BASE 0x00F2B0

#define SPI1_DTR		(SPI1_BASE + 3)
#define SPI1_DRR		(SPI1_BASE + 2)
#define SPI1_DSR		(SPI1_BASE + 1)
#define SPI1_SCR		(SPI1_BASE + 0)




// Computer Operating Properly (COP) 

//#define COP_BASE	(0x00F2C0)

#define COPCNTR	(COP_BASE + 2)
//#define COPTO	(COP_BASE + 1)
//#define COPCTL	(COP_BASE + 0)



// Interrupt controller 

#define INTC_BASE 0x00F1A0

//#define ICTL	(INTC_BASE + 0x1D)
#define TIRQS5	(INTC_BASE + 0x1C)
#define TIRQS4	(INTC_BASE + 0x1B)
#define TIRQS3	(INTC_BASE + 0x1A)
#define TIRQS2	(INTC_BASE + 0x19)
#define TIRQS1	(INTC_BASE + 0x18)
#define TIRQS0	(INTC_BASE + 0x17)
//#define IRQP5	(INTC_BASE + 0x16)
//#define IRQP4	(INTC_BASE + 0x15)
//#define IRQP3	(INTC_BASE + 0x14)
//#define IRQP2	(INTC_BASE + 0x13)
//#define IRQP1	(INTC_BASE + 0x12)
//#define IRQP0	(INTC_BASE + 0x11)
//#define FIVAH1	(INTC_BASE + 0x10)
//#define FIVAL1	(INTC_BASE + 0xF)
//#define FIM1	(INTC_BASE + 0xE)
//#define FIVAH0	(INTC_BASE + 0xD)
//#define FIVAL0	(INTC_BASE + 0xC)
//#define FIM0	(INTC_BASE + 0xB)
//#define VBA		(INTC_BASE + 0xA)
//#define IPR9	(INTC_BASE + 0x9)
//#define IPR8	(INTC_BASE + 0x8)
//#define IPR7	(INTC_BASE + 0x7)
//#define IPR6	(INTC_BASE + 0x6)
//#define IPR5	(INTC_BASE + 0x5)
//#define IPR4	(INTC_BASE + 0x4)
//#define IPR3	(INTC_BASE + 0x3)
//#define IPR2	(INTC_BASE + 0x2)
//#define IPR1	(INTC_BASE + 0x1)
//#define IPR0	(INTC_BASE + 0x0)



// System Integration Module (SIM) 

//#define SIM_BASE	(0x00F350)

//#define SIM_PCE2    (SIM_BASE + 0xF)
//#define SIM_ISALL   (SIM_BASE + 0xE)
//#define SIM_ISALH   (SIM_BASE + 0xD)
//#define SIM_PCE     (SIM_BASE + 0xC)
//#define SIM_GPS     (SIM_BASE + 0xB)
//#define SIM_CLKOSR  (SIM_BASE + 0xA)
//#define SIM_PUDR    (SIM_BASE + 0x8)
//#define SIM_LSH_ID  (SIM_BASE + 0x7)
//#define SIM_MSH_ID  (SIM_BASE + 0x6)
//#define SIM_SCR3    (SIM_BASE + 0x5)
//#define SIM_SCR2    (SIM_BASE + 0x4)
//#define SIM_SCR1    (SIM_BASE + 0x3)
//#define SIM_SCR0    (SIM_BASE + 0x2)
//#define SIM_RSTSTS  (SIM_BASE + 0x1)
//#define SIM_CONTROL (SIM_BASE + 0x0)



// timer 

////#define TMRD_BASE  0x00F100

#define TMR_D3_COMSCR (TMRD_BASE + 0x3A)
#define TMR_D3_CMPLD2 (TMRD_BASE + 0x39)
#define TMR_D3_CMPLD1 (TMRD_BASE + 0x38)
#define TMR_D3_SCR    (TMRD_BASE + 0x37)
#define TMR_D3_CTRL   (TMRD_BASE + 0x36)
#define TMR_D3_CNTR   (TMRD_BASE + 0x35)
#define TMR_D3_HOLD   (TMRD_BASE + 0x34)
#define TMR_D3_LOAD   (TMRD_BASE + 0x33)
#define TMR_D3_CAP    (TMRD_BASE + 0x32)
#define TMR_D3_CMP2   (TMRD_BASE + 0x31)
#define TMR_D3_CMP1   (TMRD_BASE + 0x30)

#define TMR_D2_COMSCR (TMRD_BASE + 0x2A)
#define TMR_D2_CMPLD2 (TMRD_BASE + 0x29)
#define TMR_D2_CMPLD1 (TMRD_BASE + 0x28)
#define TMR_D2_SCR    (TMRD_BASE + 0x27)
#define TMR_D2_CTRL   (TMRD_BASE + 0x26)
#define TMR_D2_CNTR   (TMRD_BASE + 0x25)
#define TMR_D2_HOLD   (TMRD_BASE + 0x24)
#define TMR_D2_LOAD   (TMRD_BASE + 0x23)
#define TMR_D2_CAP    (TMRD_BASE + 0x22)
#define TMR_D2_CMP2   (TMRD_BASE + 0x21)
#define TMR_D2_CMP1   (TMRD_BASE + 0x20)

#define TMR_D1_COMSCR (TMRD_BASE + 0x1A)
#define TMR_D1_CMPLD2 (TMRD_BASE + 0x19)
#define TMR_D1_CMPLD1 (TMRD_BASE + 0x18)
#define TMR_D1_SCR    (TMRD_BASE + 0x17)
#define TMR_D1_CTRL   (TMRD_BASE + 0x16)
#define TMR_D1_CNTR   (TMRD_BASE + 0x15)
#define TMR_D1_HOLD   (TMRD_BASE + 0x14)
#define TMR_D1_LOAD   (TMRD_BASE + 0x13)
#define TMR_D1_CAP    (TMRD_BASE + 0x12)
#define TMR_D1_CMP2   (TMRD_BASE + 0x11)
#define TMR_D1_CMP1   (TMRD_BASE + 0x10)

#define TMR_D0_COMSCR (TMRD_BASE + 0xA)
#define TMR_D0_CMPLD2 (TMRD_BASE + 0x9)
#define TMR_D0_CMPLD1 (TMRD_BASE + 0x8)
#define TMR_D0_SCR    (TMRD_BASE + 0x7)
#define TMR_D0_CTRL   (TMRD_BASE + 0x6)
#define TMR_D0_CNTR   (TMRD_BASE + 0x5)
#define TMR_D0_HOLD   (TMRD_BASE + 0x4)
#define TMR_D0_LOAD   (TMRD_BASE + 0x3)
#define TMR_D0_CAP    (TMRD_BASE + 0x2)
#define TMR_D0_CMP2   (TMRD_BASE + 0x1)
#define TMR_D0_CMP1   (TMRD_BASE + 0x0)




//#define TMRC_BASE  0x00F0C0

#define TMR_C3_COMSCR (TMRC_BASE + 0x3A)
#define TMR_C3_CMPLD2 (TMRC_BASE + 0x39)
#define TMR_C3_CMPLD1 (TMRC_BASE + 0x38)
#define TMR_C3_SCR    (TMRC_BASE + 0x37)
#define TMR_C3_CTRL   (TMRC_BASE + 0x36)
#define TMR_C3_CNTR   (TMRC_BASE + 0x35)
#define TMR_C3_HOLD   (TMRC_BASE + 0x34)
#define TMR_C3_LOAD   (TMRC_BASE + 0x33)
#define TMR_C3_CAP    (TMRC_BASE + 0x32)
#define TMR_C3_CMP2   (TMRC_BASE + 0x31)
#define TMR_C3_CMP1   (TMRC_BASE + 0x30)

#define TMR_C2_COMSCR (TMRC_BASE + 0x2A)
#define TMR_C2_CMPLD2 (TMRC_BASE + 0x29)
#define TMR_C2_CMPLD1 (TMRC_BASE + 0x28)
#define TMR_C2_SCR    (TMRC_BASE + 0x27)
#define TMR_C2_CTRL   (TMRC_BASE + 0x26)
#define TMR_C2_CNTR   (TMRC_BASE + 0x25)
#define TMR_C2_HOLD   (TMRC_BASE + 0x24)
#define TMR_C2_LOAD   (TMRC_BASE + 0x23)
#define TMR_C2_CAP    (TMRC_BASE + 0x22)
#define TMR_C2_CMP2   (TMRC_BASE + 0x21)
#define TMR_C2_CMP1   (TMRC_BASE + 0x20)

#define TMR_C1_COMSCR (TMRC_BASE + 0x1A)
#define TMR_C1_CMPLD2 (TMRC_BASE + 0x19)
#define TMR_C1_CMPLD1 (TMRC_BASE + 0x18)
#define TMR_C1_SCR    (TMRC_BASE + 0x17)
#define TMR_C1_CTRL   (TMRC_BASE + 0x16)
#define TMR_C1_CNTR   (TMRC_BASE + 0x15)
#define TMR_C1_HOLD   (TMRC_BASE + 0x14)
#define TMR_C1_LOAD   (TMRC_BASE + 0x13)
#define TMR_C1_CAP    (TMRC_BASE + 0x12)
#define TMR_C1_CMP2   (TMRC_BASE + 0x11)
#define TMR_C1_CMP1   (TMRC_BASE + 0x10)

#define TMR_C0_COMSCR (TMRC_BASE + 0xA)
#define TMR_C0_CMPLD2 (TMRC_BASE + 0x9)
#define TMR_C0_CMPLD1 (TMRC_BASE + 0x8)
#define TMR_C0_SCR    (TMRC_BASE + 0x7)
#define TMR_C0_CTRL   (TMRC_BASE + 0x6)
#define TMR_C0_CNTR   (TMRC_BASE + 0x5)
#define TMR_C0_HOLD   (TMRC_BASE + 0x4)
#define TMR_C0_LOAD   (TMRC_BASE + 0x3)
#define TMR_C0_CAP    (TMRC_BASE + 0x2)
#define TMR_C0_CMP2   (TMRC_BASE + 0x1)
#define TMR_C0_CMP1   (TMRC_BASE + 0x0)



//#define TMRB_BASE  0x00F080

#define TMR_B3_COMSCR (TMRB_BASE + 0x3A)
#define TMR_B3_CMPLD2 (TMRB_BASE + 0x39)
#define TMR_B3_CMPLD1 (TMRB_BASE + 0x38)
#define TMR_B3_SCR    (TMRB_BASE + 0x37)
#define TMR_B3_CTRL   (TMRB_BASE + 0x36)
#define TMR_B3_CNTR   (TMRB_BASE + 0x35)
#define TMR_B3_HOLD   (TMRB_BASE + 0x34)
#define TMR_B3_LOAD   (TMRB_BASE + 0x33)
#define TMR_B3_CAP    (TMRB_BASE + 0x32)
#define TMR_B3_CMP2   (TMRB_BASE + 0x31)
#define TMR_B3_CMP1   (TMRB_BASE + 0x30)

#define TMR_B2_COMSCR (TMRB_BASE + 0x2A)
#define TMR_B2_CMPLD2 (TMRB_BASE + 0x29)
#define TMR_B2_CMPLD1 (TMRB_BASE + 0x28)
#define TMR_B2_SCR    (TMRB_BASE + 0x27)
#define TMR_B2_CTRL   (TMRB_BASE + 0x26)
#define TMR_B2_CNTR   (TMRB_BASE + 0x25)
#define TMR_B2_HOLD   (TMRB_BASE + 0x24)
#define TMR_B2_LOAD   (TMRB_BASE + 0x23)
#define TMR_B2_CAP    (TMRB_BASE + 0x22)
#define TMR_B2_CMP2   (TMRB_BASE + 0x21)
#define TMR_B2_CMP1   (TMRB_BASE + 0x20)

#define TMR_B1_COMSCR (TMRB_BASE + 0x1A)
#define TMR_B1_CMPLD2 (TMRB_BASE + 0x19)
#define TMR_B1_CMPLD1 (TMRB_BASE + 0x18)
#define TMR_B1_SCR    (TMRB_BASE + 0x17)
#define TMR_B1_CTRL   (TMRB_BASE + 0x16)
#define TMR_B1_CNTR   (TMRB_BASE + 0x15)
#define TMR_B1_HOLD   (TMRB_BASE + 0x14)
#define TMR_B1_LOAD   (TMRB_BASE + 0x13)
#define TMR_B1_CAP    (TMRB_BASE + 0x12)
#define TMR_B1_CMP2   (TMRB_BASE + 0x11)
#define TMR_B1_CMP1   (TMRB_BASE + 0x10)

#define TMR_B0_COMSCR (TMRB_BASE + 0xA)
#define TMR_B0_CMPLD2 (TMRB_BASE + 0x9)
#define TMR_B0_CMPLD1 (TMRB_BASE + 0x8)
#define TMR_B0_SCR    (TMRB_BASE + 0x7)
#define TMR_B0_CTRL   (TMRB_BASE + 0x6)
#define TMR_B0_CNTR   (TMRB_BASE + 0x5)
#define TMR_B0_HOLD   (TMRB_BASE + 0x4)
#define TMR_B0_LOAD   (TMRB_BASE + 0x3)
#define TMR_B0_CAP    (TMRB_BASE + 0x2)
#define TMR_B0_CMP2   (TMRB_BASE + 0x1)
#define TMR_B0_CMP1   (TMRB_BASE + 0x0)




//#define TMRA_BASE  0x00F040

#define TMR_A3_COMSCR (TMRA_BASE + 0x3A)
#define TMR_A3_CMPLD2 (TMRA_BASE + 0x39)
#define TMR_A3_CMPLD1 (TMRA_BASE + 0x38)
#define TMR_A3_SCR    (TMRA_BASE + 0x37)
#define TMR_A3_CTRL   (TMRA_BASE + 0x36)
#define TMR_A3_CNTR   (TMRA_BASE + 0x35)
#define TMR_A3_HOLD   (TMRA_BASE + 0x34)
#define TMR_A3_LOAD   (TMRA_BASE + 0x33)
#define TMR_A3_CAP    (TMRA_BASE + 0x32)
#define TMR_A3_CMP2   (TMRA_BASE + 0x31)
#define TMR_A3_CMP1   (TMRA_BASE + 0x30)

#define TMR_A2_COMSCR (TMRA_BASE + 0x2A)
#define TMR_A2_CMPLD2 (TMRA_BASE + 0x29)
#define TMR_A2_CMPLD1 (TMRA_BASE + 0x28)
#define TMR_A2_SCR    (TMRA_BASE + 0x27)
#define TMR_A2_CTRL   (TMRA_BASE + 0x26)
#define TMR_A2_CNTR   (TMRA_BASE + 0x25)
#define TMR_A2_HOLD   (TMRA_BASE + 0x24)
#define TMR_A2_LOAD   (TMRA_BASE + 0x23)
#define TMR_A2_CAP    (TMRA_BASE + 0x22)
#define TMR_A2_CMP2   (TMRA_BASE + 0x21)
#define TMR_A2_CMP1   (TMRA_BASE + 0x20)

#define TMR_A1_COMSCR (TMRA_BASE + 0x1A)
#define TMR_A1_CMPLD2 (TMRA_BASE + 0x19)
#define TMR_A1_CMPLD1 (TMRA_BASE + 0x18)
#define TMR_A1_SCR    (TMRA_BASE + 0x17)
#define TMR_A1_CTRL   (TMRA_BASE + 0x16)
#define TMR_A1_CNTR   (TMRA_BASE + 0x15)
#define TMR_A1_HOLD   (TMRA_BASE + 0x14)
#define TMR_A1_LOAD   (TMRA_BASE + 0x13)
#define TMR_A1_CAP    (TMRA_BASE + 0x12)
#define TMR_A1_CMP2   (TMRA_BASE + 0x11)
#define TMR_A1_CMP1   (TMRA_BASE + 0x10)

#define TMR_A0_COMSCR (TMRA_BASE + 0xA)
#define TMR_A0_CMPLD2 (TMRA_BASE + 0x9)
#define TMR_A0_CMPLD1 (TMRA_BASE + 0x8)
#define TMR_A0_SCR    (TMRA_BASE + 0x7)
#define TMR_A0_CTRL   (TMRA_BASE + 0x6)
#define TMR_A0_CNTR   (TMRA_BASE + 0x5)
#define TMR_A0_HOLD   (TMRA_BASE + 0x4)
#define TMR_A0_LOAD   (TMRA_BASE + 0x3)
#define TMR_A0_CAP    (TMRA_BASE + 0x2)
#define TMR_A0_CMP2   (TMRA_BASE + 0x1)
#define TMR_A0_CMP1   (TMRA_BASE + 0x0)




// General Purpose Input/Output (GPIO) 

//#define GPIOA_BASE 0x00F2E0

#define GPIO_A_RAWDATA	(GPIOA_BASE + 0xA)
#define GPIO_A_PPMODE   (GPIOA_BASE + 0x9)
#define GPIO_A_IESR		(GPIOA_BASE + 0x8)
#define GPIO_A_IPR		(GPIOA_BASE + 0x7)
#define GPIO_A_IPOLR	(GPIOA_BASE + 0x6)
#define GPIO_A_IENR		(GPIOA_BASE + 0x5)
#define GPIO_A_IAR		(GPIOA_BASE + 0x4)
#define GPIO_A_PER		(GPIOA_BASE + 0x3)
#define GPIO_A_DDR		(GPIOA_BASE + 0x2)
#define GPIO_A_DR		(GPIOA_BASE + 0x1)
#define GPIO_A_PUR		(GPIOA_BASE + 0x0)



//#define GPIOB_BASE 0x00F300

#define GPIO_B_RAWDATA	(GPIOB_BASE + 0xA)
#define GPIO_B_PPMODE   (GPIOB_BASE + 0x9)
#define GPIO_B_IESR		(GPIOB_BASE + 0x8)
#define GPIO_B_IPR		(GPIOB_BASE + 0x7)
#define GPIO_B_IPOLR	(GPIOB_BASE + 0x6)
#define GPIO_B_IENR		(GPIOB_BASE + 0x5)
#define GPIO_B_IAR		(GPIOB_BASE + 0x4)
#define GPIO_B_PER		(GPIOB_BASE + 0x3)
#define GPIO_B_DDR		(GPIOB_BASE + 0x2)
#define GPIO_B_DR		(GPIOB_BASE + 0x1)
#define GPIO_B_PUR		(GPIOB_BASE + 0x0)


//#define GPIOC_BASE 0x00F310

#define GPIO_C_RAWDATA	(GPIOC_BASE + 0xA)
#define GPIO_C_PPMODE   (GPIOC_BASE + 0x9)
#define GPIO_C_IESR		(GPIOC_BASE + 0x8)
#define GPIO_C_IPR		(GPIOC_BASE + 0x7)
#define GPIO_C_IPOLR	(GPIOC_BASE + 0x6)
#define GPIO_C_IENR		(GPIOC_BASE + 0x5)
#define GPIO_C_IAR		(GPIOC_BASE + 0x4)
#define GPIO_C_PER		(GPIOC_BASE + 0x3)
#define GPIO_C_DDR		(GPIOC_BASE + 0x2)
#define GPIO_C_DR		(GPIOC_BASE + 0x1)
#define GPIO_C_PUR		(GPIOC_BASE + 0x0)


//#define GPIOD_BASE 0x00F320

#define GPIO_D_RAWDATA	(GPIOD_BASE + 0xA)
#define GPIO_D_PPMODE   (GPIOD_BASE + 0x9)
#define GPIO_D_IESR		(GPIOD_BASE + 0x8)
#define GPIO_D_IPR		(GPIOD_BASE + 0x7)
#define GPIO_D_IPOLR	(GPIOD_BASE + 0x6)
#define GPIO_D_IENR		(GPIOD_BASE + 0x5)
#define GPIO_D_IAR		(GPIOD_BASE + 0x4)
#define GPIO_D_PER		(GPIOD_BASE + 0x3)
#define GPIO_D_DDR		(GPIOD_BASE + 0x2)
#define GPIO_D_DR		(GPIOD_BASE + 0x1)
#define GPIO_D_PUR		(GPIOD_BASE + 0x0)


//#define GPIOE_BASE 0x00F330

#define GPIO_E_RAWDATA	(GPIOE_BASE + 0xA)
#define GPIO_E_PPMODE   (GPIOE_BASE + 0x9)
#define GPIO_E_IESR		(GPIOE_BASE + 0x8)
#define GPIO_E_IPR		(GPIOE_BASE + 0x7)
#define GPIO_E_IPOLR	(GPIOE_BASE + 0x6)
#define GPIO_E_IENR		(GPIOE_BASE + 0x5)
#define GPIO_E_IAR		(GPIOE_BASE + 0x4)
#define GPIO_E_PER		(GPIOE_BASE + 0x3)
#define GPIO_E_DDR		(GPIOE_BASE + 0x2)
#define GPIO_E_DR		(GPIOE_BASE + 0x1)
#define GPIO_E_PUR		(GPIOE_BASE + 0x0)



//#define GPIOF_BASE 0x00F340

#define GPIO_F_RAWDATA	(GPIOF_BASE + 0xA)
#define GPIO_F_PPMODE   (GPIOF_BASE + 0x9)
#define GPIO_F_IESR		(GPIOF_BASE + 0x8)
#define GPIO_F_IPR		(GPIOF_BASE + 0x7)
#define GPIO_F_IPOLR	(GPIOF_BASE + 0x6)
#define GPIO_F_IENR		(GPIOF_BASE + 0x5)
#define GPIO_F_IAR		(GPIOF_BASE + 0x4)
#define GPIO_F_PER		(GPIOF_BASE + 0x3)
#define GPIO_F_DDR		(GPIOF_BASE + 0x2)
#define GPIO_F_DR		(GPIOF_BASE + 0x1)
#define GPIO_F_PUR		(GPIOF_BASE + 0x0)




// External Memory Interface 

//#define EMI_BASE 0xFFF020

//#define BCR			(EMI_BASE + 0x10)
#define CSOR_7		(EMI_BASE + 0xF)
#define CSOR_6		(EMI_BASE + 0xE)
#define CSOR_5		(EMI_BASE + 0xD)
#define CSOR_4		(EMI_BASE + 0xC)
#define CSOR_3		(EMI_BASE + 0xB)
#define CSOR_2		(EMI_BASE + 0xA)
#define CSOR_1		(EMI_BASE + 0x9)
#define CSOR_0		(EMI_BASE + 0x8)
#define CSBAR_7		(EMI_BASE + 0x7)
#define CSBAR_6		(EMI_BASE + 0x6)
#define CSBAR_5		(EMI_BASE + 0x5)
#define CSBAR_4		(EMI_BASE + 0x4)
#define CSBAR_3		(EMI_BASE + 0x3)
#define CSBAR_2		(EMI_BASE + 0x2)
#define CSBAR_1		(EMI_BASE + 0x1)
#define CSBAR_0		(EMI_BASE + 0x0)

#endif

